SystemOrganization addCategory: #AMMStudio!
SystemOrganization addCategory: #'AMMStudio-Example'!
SystemOrganization addCategory: #'AMMStudio-Test'!
SystemOrganization addCategory: #'AMMStudio-Units'!
SystemOrganization addCategory: #'AMMStudio-Widgets'!

Trait named: #AMMObjectRepresentationDrawing
	uses: {}
	category: 'AMMStudio'!

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/25/2013 18:45:28.399'!
handleObjectChanged

	self object ifNotNil: [ 
		self setBorderColor.
		self setColor.
		self setTooltip.		
	].
! !

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 13:50:44.223'!
registerSignalsForObject

	self connect: self object signal: #changed toSelector: #handleObjectChanged.

! !

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 16:51:25.747'!
setBorderColor 

	(self object isNil)
		ifTrue: [ self borderColor: AMMObjectsRepresentation emptyColor ]
		ifFalse: [
			(self object hovered)
				ifTrue: [ self borderColor: AMMObjectsRepresentation defaultBorderColorOnHover ]
				ifFalse: [
					(self object isRoot)
						ifTrue: [ self borderColor: AMMObjectsRepresentation defaultBorderColorIfRoot  ]
						ifFalse: [ self borderColor: AMMObjectsRepresentation defaultBorderColor ] 
				]
		]! !

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 16:35:11.921'!
setColor 
	
	(self object isNil)
		ifTrue: [ self borderColor: AMMObjectsRepresentation defaultColor ]
		ifFalse: [
			(self object state = #marked) 
				ifTrue: [ self color: AMMObjectsRepresentation markedColor ]
				ifFalse: [ 
					((self object state = #active) or: (self object flag = #activeTraversal)) 
						ifTrue: [ self color: AMMObjectsRepresentation activeColor ]
						ifFalse: [ 
							(self object flag = #doneTraversal)
								ifTrue: [self color: AMMObjectsRepresentation visitedColor ]
								ifFalse: [self color: AMMObjectsRepresentation defaultColor ].					
							] 
					]
			]! !

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 16:37:10.787'!
setTooltip

	| text |
	text := ''.
	self object ifNotNil: [ 
		self object name	ifNotNil: [ text := self object name, Character cr. ].
		text :=  text, 'Type: ', self object object class, Character cr, 'Size: ', self object sizeOfObject.
		].

	self setBalloonText: text.! !

!AMMObjectRepresentationDrawing methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 13:50:33.012'!
unregisterSignalsForObject

	self disconnectSignal: #changed from: self object.

! !

NCEllipseMorph subclass: #AMMObjectNode
	uses: AMMObjectRepresentationDrawing
	instanceVariableNames: 'object references referenceCountMorph objectNodeReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectNode class
	uses: AMMObjectRepresentationDrawing classTrait
	instanceVariableNames: ''!

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.212'!
defaultBorderWidth 

	^ 3! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:13:04.64'!
defaultHeight 

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 15:50:07.923'!
defaultOffset

	^ 60
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:12:58.993'!
defaultWidth

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:44:43.601'!
newFor: anObject atPosition: aPosition
	| node|
	
	node := self new.
	node position: aPosition.
	node object: anObject.
	node object state = #marked ifTrue: [ node color: AMMObjectsRepresentation markedColor ].	

	
	^ node! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'ci 6/16/2013 13:27:13.589'!
balloonColor
	^ AMMBalloonMorph balloonColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'ci 6/16/2013 17:17:51.917'!
balloonHelpDelayTime
	^ 50.! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 5/27/2013 11:17:38.637'!
click

	self object toggleState.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:26:22.19'!
connectedNodes

	| nodes |
	nodes := OrderedCollection new.
	
	self connectedConstraints do: [ :ownConstraint | 
			| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			nodes add: node
			]
	].

	^ nodes! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'ci 6/16/2013 13:28:40.521'!
defaultBorderColorOnHover
	^ Color orange.! !

!AMMObjectNode methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/26/2013 00:24:29.476'!
handleObjectChanged

	self object ifNotNil: [ 
		self setBorderColor.
		self setColor.
		self setTooltip.
		self setReferenceCount.
	].
! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 6/17/2013 12:24:18.204'!
handlesMouseOver: evt

	^ true! !

!AMMObjectNode methodsFor: 'initialization' stamp: 'sw 6/26/2013 00:45:24.325'!
initialize 

	super initialize.

	self color: Color white.
	self borderWidth: self class defaultBorderWidth.
	self removeAllMorphs.
	
	self referenceCountMorph: StringMorph new.
	self addMorph: referenceCountMorph.
	self referenceCountMorph lock;
		width:200;
		height:200.
	
	self height: self class defaultHeight.
	self width: self class defaultWidth.
	
	self on: #click send: #click to: self.
	
	
	! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'ci 6/23/2013 13:02:22.316'!
mouseLeave: evt

	self object hovered: false.! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 6/17/2013 12:31:49.389'!
mouseOver: evt

	self object hovered: true.
! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.198'!
object

	^ object! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 6/26/2013 00:45:53.172'!
object: anObject

	object ifNotNil: [ self unregisterSignalsForObject ].
	object := anObject.	
	object ifNotNil: [ 
		self setTooltip.
		self setBorderColor.
		self setColor.
		self setReferenceCount.
			
		self registerSignalsForObject 
	].
	
	! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'ci 6/23/2013 12:08:55.213'!
objectNodeReference

	^ objectNodeReference ifNil: [ 
		objectNodeReference := (AMMObjectNodeReference newAt: (self position) ).
		self addMorph: (self objectNodeReference).
		^ objectNodeReference.
	]! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'ci 6/23/2013 11:05:33.584'!
objectNodeReference: anObject

	objectNodeReference := anObject! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:25:16.054'!
referenceCountMorph

	^ referenceCountMorph! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:25:16.056'!
referenceCountMorph: anObject

	referenceCountMorph := anObject! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'ci 6/23/2013 11:03:50.227'!
references

	^ references! !

!AMMObjectNode methodsFor: 'accessing' stamp: 'ci 6/23/2013 12:07:15.742'!
references: anInteger

	references := anInteger.
	(self objectNodeReference) textMorph contents: (self references) asString.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:40:10.394'!
refresh 

	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:39:43.918'!
removeConnectorToNode: aNode

	self connectedConstraints do: [ :ownConstraint | 
		| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			(node = aNode)
				ifTrue: [ 
					connectorMorph delete. 
					^ self
				].
			]
		].	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 16:16:10.845'!
removeUnreferencedConnectors 

	self connectedNodes do:[ :connectedNode |
		((self object references includes: connectedNode object) or:
		( connectedNode object references includes: self object))
			ifFalse: [ self removeConnectorToNode: connectedNode ]
	
	].! !

!AMMObjectNode methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/26/2013 00:37:41.728'!
setReferenceCount

	(self owner isNil)
		ifFalse: [
			(self owner showReferenceCount) 
				ifTrue: [ self referenceCountMorph contents: self object referenceCount asString ]
				ifFalse: [self referenceCountMorph contents: '' ]
		]
		ifTrue: [self referenceCountMorph contents: '' ]! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 6/17/2013 11:51:50.145'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	| w balloon h |
	
	(w := self world) ifNil: [^ self].
	h := aHand.
	h ifNil:[
		h := w activeHand].
	balloon := AMMBalloonMorph string: msgString for: self balloonHelpAligner.
	balloon popUpFor: self hand: h.
	
	"change the morph itself"
	self object toggleHover.! !

UserInterface subclass: #AMMStudioUi
	instanceVariableNames: 'progressBarContainer comboUnits buttonPause buttonPlay buttonStep progressBar sourceCodeEdit buttonPrevious buttonNext containerHeapGC containerHeap containerGC containerGraph scrollAreaGraph containerLegend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.547'!
buttonNext
	"No description given."
	
	^ buttonNext! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.534'!
buttonPause
	"No description given."
	
	^ buttonPause! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.536'!
buttonPlay
	"Play Scenario"
	
	^ buttonPlay! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.544'!
buttonPrevious
	"No description given."
	
	^ buttonPrevious! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.538'!
buttonStep
	"GC Stepping"
	
	^ buttonStep! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.531'!
comboUnits
	"No description given."
	
	^ comboUnits! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.554'!
containerGC	
	"container for gc"
	
	^ containerGC	! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.556'!
containerGraph
	"No description given."
	
	^ containerGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.551'!
containerHeap
	"container for heap representation"
	
	^ containerHeap! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.549'!
containerHeapGC
	"Container for the heap presentation and gc"
	
	^ containerHeapGC! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.56'!
containerLegend
	"No description given."
	
	^ containerLegend! !

!AMMStudioUi methodsFor: 'ui - private' stamp: 'sw 6/18/2013 17:54:18.239'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (756@466).
	panel position: (0@0).
	panel hResizing: (#shrinkWrap).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#topLeft).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	progressBarContainer := UiContainer new.
	progressBarContainer changeTableLayout.
	progressBarContainer extent: (460@458).
	progressBarContainer position: (4@4).
	progressBarContainer hResizing: (#spaceFill).
	progressBarContainer vResizing: (#spaceFill).
	progressBarContainer minWidth: (300).
	progressBarContainer minHeight: (2).
	progressBarContainer cellInset: (4).
	progressBarContainer cellPositioning: (#center).
	progressBarContainer cellSpacing: (#none).
	progressBarContainer layoutInset: (4).
	progressBarContainer listCentering: (#topLeft).
	progressBarContainer listDirection: (#topToBottom).
	progressBarContainer listSpacing: (#none).
	progressBarContainer maxCellSize: (1073741823).
	progressBarContainer minCellSize: (0).
	progressBarContainer wrapCentering: (#topLeft).
	progressBarContainer wrapDirection: (#none).
	progressBarContainer frameFractions: (0@0 corner: 1@1).
	progressBarContainer frameOffsets: (0@0 corner: 0@0).
	progressBarContainer balloonText: (nil).
	progressBarContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	progressBarContainer color: (Color transparent).
	progressBarContainer borderWidth: (0).
	progressBarContainer borderStyle2: (#simple).
	progressBarContainer borderColor: (Color black).
	progressBarContainer setProperty: #objectName toValue: 'progressBarContainer'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (452@30).
	unnamedMorph1 position: (8@8).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#topLeft).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph1 setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	comboUnits := UiComboBox new.
	comboUnits extent: (110@21).
	comboUnits position: (12@12).
	comboUnits hResizing: (#rigid).
	comboUnits vResizing: (#rigid).
	comboUnits minWidth: (2).
	comboUnits minHeight: (2).
	comboUnits cellInset: (0).
	comboUnits cellPositioning: (#center).
	comboUnits cellSpacing: (#none).
	comboUnits layoutInset: (0).
	comboUnits listCentering: (#topLeft).
	comboUnits listDirection: (#topToBottom).
	comboUnits listSpacing: (#none).
	comboUnits maxCellSize: (1073741823).
	comboUnits minCellSize: (0).
	comboUnits wrapCentering: (#topLeft).
	comboUnits wrapDirection: (#none).
	comboUnits frameFractions: (0@0 corner: 1@1).
	comboUnits frameOffsets: (0@0 corner: 0@0).
	comboUnits balloonText: (nil).
	comboUnits balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	comboUnits readOnly: (true).
	comboUnits setProperty: #objectName toValue: 'comboUnits'.
	unnamedMorph1 addChild: comboUnits.

	progressBarContainer addChild: unnamedMorph1.
	progressBar := AMMProgressBar new.
	progressBar extent: (340@20).
	progressBar position: (64@43).
	progressBar hResizing: (#rigid).
	progressBar vResizing: (#rigid).
	progressBar minWidth: (2).
	progressBar minHeight: (2).
	progressBar cellInset: (0).
	progressBar cellPositioning: (#center).
	progressBar cellSpacing: (#none).
	progressBar layoutInset: (0).
	progressBar listCentering: (#topLeft).
	progressBar listDirection: (#topToBottom).
	progressBar listSpacing: (#none).
	progressBar maxCellSize: (1073741823).
	progressBar minCellSize: (0).
	progressBar wrapCentering: (#topLeft).
	progressBar wrapDirection: (#none).
	progressBar frameFractions: (0@0 corner: 1@1).
	progressBar frameOffsets: (0@0 corner: 0@0).
	progressBar balloonText: (nil).
	progressBar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	progressBar setProperty: #objectName toValue: 'progressBar'.
	progressBarContainer addChild: progressBar.
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (452@391).
	unnamedMorph2 position: (8@67).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#spaceFill).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	sourceCodeEdit := AMMSourceCodeEdit new.
	sourceCodeEdit extent: (444@349).
	sourceCodeEdit position: (12@71).
	sourceCodeEdit hResizing: (#spaceFill).
	sourceCodeEdit vResizing: (#spaceFill).
	sourceCodeEdit minWidth: (2).
	sourceCodeEdit minHeight: (2).
	sourceCodeEdit cellInset: (0).
	sourceCodeEdit cellPositioning: (#center).
	sourceCodeEdit cellSpacing: (#none).
	sourceCodeEdit layoutInset: (0).
	sourceCodeEdit listCentering: (#topLeft).
	sourceCodeEdit listDirection: (#topToBottom).
	sourceCodeEdit listSpacing: (#none).
	sourceCodeEdit maxCellSize: (1073741823).
	sourceCodeEdit minCellSize: (0).
	sourceCodeEdit wrapCentering: (#topLeft).
	sourceCodeEdit wrapDirection: (#none).
	sourceCodeEdit frameFractions: (0@0 corner: 1@1).
	sourceCodeEdit frameOffsets: (0@0 corner: 0@0).
	sourceCodeEdit balloonText: (nil).
	sourceCodeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	sourceCodeEdit widgetResizable: (true).
	sourceCodeEdit horizontalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit verticalScrollBarPolicy: (#alwaysOn).
	sourceCodeEdit outerBorderWidth: (1).
	sourceCodeEdit scrollBarThickness: (9).
	sourceCodeEdit theText: ('').
	sourceCodeEdit readOnly: (false).
	sourceCodeEdit autoConvert: (false).
	sourceCodeEdit autoAccept: (false).
	sourceCodeEdit acceptOnFocusLost: (false).
	sourceCodeEdit scrollingMode: (#none).
	sourceCodeEdit scrollingLimit: (10).
	sourceCodeEdit setProperty: #objectName toValue: 'sourceCodeEdit'.
	unnamedMorph2 addChild: sourceCodeEdit.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (444@30).
	unnamedMorph3 position: (12@424).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	buttonPrevious := UiPushButton new.
	buttonPrevious changeTableLayout.
	buttonPrevious extent: (75@21).
	buttonPrevious position: (16@428).
	buttonPrevious hResizing: (#shrinkWrap).
	buttonPrevious vResizing: (#shrinkWrap).
	buttonPrevious minWidth: (2).
	buttonPrevious minHeight: (2).
	buttonPrevious cellInset: (4).
	buttonPrevious cellPositioning: (#center).
	buttonPrevious cellSpacing: (#none).
	buttonPrevious layoutInset: (2@0 corner: 2@0).
	buttonPrevious listCentering: (#topLeft).
	buttonPrevious listDirection: (#leftToRight).
	buttonPrevious listSpacing: (#none).
	buttonPrevious maxCellSize: (1073741823).
	buttonPrevious minCellSize: (0).
	buttonPrevious wrapCentering: (#topLeft).
	buttonPrevious wrapDirection: (#none).
	buttonPrevious frameFractions: (0@0 corner: 1@1).
	buttonPrevious frameOffsets: (0@0 corner: 0@0).
	buttonPrevious balloonText: (nil).
	buttonPrevious balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonPrevious enabled: (true).
	buttonPrevious setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0332Normal'.
	buttonPrevious icon: (UiDiagonaIcons icon0332Normal).
	buttonPrevious text: ('Previous').
	buttonPrevious color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPrevious checkable: (false).
	buttonPrevious checked: (false).
	buttonPrevious autoExclusive: (false).
	buttonPrevious setProperty: #objectName toValue: 'buttonPrevious'.
	unnamedMorph3 addChild: buttonPrevious.
	buttonNext := UiPushButton new.
	buttonNext changeTableLayout.
	buttonNext extent: (53@21).
	buttonNext position: (97@428).
	buttonNext hResizing: (#shrinkWrap).
	buttonNext vResizing: (#shrinkWrap).
	buttonNext minWidth: (2).
	buttonNext minHeight: (2).
	buttonNext cellInset: (4).
	buttonNext cellPositioning: (#center).
	buttonNext cellSpacing: (#none).
	buttonNext layoutInset: (2@0 corner: 2@0).
	buttonNext listCentering: (#topLeft).
	buttonNext listDirection: (#leftToRight).
	buttonNext listSpacing: (#none).
	buttonNext maxCellSize: (1073741823).
	buttonNext minCellSize: (0).
	buttonNext wrapCentering: (#topLeft).
	buttonNext wrapDirection: (#none).
	buttonNext frameFractions: (0@0 corner: 1@1).
	buttonNext frameOffsets: (0@0 corner: 0@0).
	buttonNext balloonText: (nil).
	buttonNext balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonNext enabled: (true).
	buttonNext setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonNext icon: (UiDiagonaIcons icon0331Normal).
	buttonNext text: ('Next').
	buttonNext color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonNext checkable: (false).
	buttonNext checked: (false).
	buttonNext autoExclusive: (false).
	buttonNext setProperty: #objectName toValue: 'buttonNext'.
	unnamedMorph3 addChild: buttonNext.
	unnamedMorph2 addChild: unnamedMorph3.
	progressBarContainer addChild: unnamedMorph2.
	panel addChild: progressBarContainer.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (284@458).
	unnamedMorph4 position: (468@4).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#spaceFill).
	unnamedMorph4 minWidth: (120).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	containerHeapGC := UiContainer new.
	containerHeapGC changeTableLayout.
	containerHeapGC extent: (276@108).
	containerHeapGC position: (472@8).
	containerHeapGC hResizing: (#spaceFill).
	containerHeapGC vResizing: (#shrinkWrap).
	containerHeapGC minWidth: (2).
	containerHeapGC minHeight: (2).
	containerHeapGC cellInset: (4).
	containerHeapGC cellPositioning: (#center).
	containerHeapGC cellSpacing: (#none).
	containerHeapGC layoutInset: (4).
	containerHeapGC listCentering: (#topLeft).
	containerHeapGC listDirection: (#leftToRight).
	containerHeapGC listSpacing: (#none).
	containerHeapGC maxCellSize: (1073741823).
	containerHeapGC minCellSize: (0).
	containerHeapGC wrapCentering: (#topLeft).
	containerHeapGC wrapDirection: (#none).
	containerHeapGC frameFractions: (0@0 corner: 1@1).
	containerHeapGC frameOffsets: (0@0 corner: 0@0).
	containerHeapGC balloonText: (nil).
	containerHeapGC balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerHeapGC color: (Color lightGray).
	containerHeapGC borderWidth: (0).
	containerHeapGC borderStyle2: (#simple).
	containerHeapGC borderColor: (Color black).
	containerHeapGC setProperty: #objectName toValue: 'containerHeapGC'.
	containerHeapGC setProperty: #objectDescription toValue: 'Container for the heap presentation and gc'.
	containerHeap := UiContainer new.
	containerHeap changeTableLayout.
	containerHeap extent: (114@100).
	containerHeap position: (476@12).
	containerHeap hResizing: (#spaceFill).
	containerHeap vResizing: (#rigid).
	containerHeap minWidth: (2).
	containerHeap minHeight: (2).
	containerHeap cellInset: (4).
	containerHeap cellPositioning: (#center).
	containerHeap cellSpacing: (#none).
	containerHeap layoutInset: (0).
	containerHeap listCentering: (#topLeft).
	containerHeap listDirection: (#leftToRight).
	containerHeap listSpacing: (#none).
	containerHeap maxCellSize: (1073741823).
	containerHeap minCellSize: (0).
	containerHeap wrapCentering: (#topLeft).
	containerHeap wrapDirection: (#none).
	containerHeap frameFractions: (0@0 corner: 1@1).
	containerHeap frameOffsets: (0@0 corner: 0@0).
	containerHeap balloonText: (nil).
	containerHeap balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerHeap color: (Color transparent).
	containerHeap borderWidth: (0).
	containerHeap borderStyle2: (#simple).
	containerHeap borderColor: (Color black).
	containerHeap setProperty: #objectName toValue: 'containerHeap'.
	containerHeap setProperty: #objectDescription toValue: 'container for heap representation'.
	containerHeapGC addChild: containerHeap.
	containerGC	 := UiContainer new.
	containerGC	 changeTableLayout.
	containerGC	 extent: (150@100).
	containerGC	 position: (594@12).
	containerGC	 hResizing: (#rigid).
	containerGC	 vResizing: (#rigid).
	containerGC	 minWidth: (2).
	containerGC	 minHeight: (2).
	containerGC	 cellInset: (0).
	containerGC	 cellPositioning: (#center).
	containerGC	 cellSpacing: (#none).
	containerGC	 layoutInset: (0).
	containerGC	 listCentering: (#topLeft).
	containerGC	 listDirection: (#leftToRight).
	containerGC	 listSpacing: (#none).
	containerGC	 maxCellSize: (1073741823).
	containerGC	 minCellSize: (0).
	containerGC	 wrapCentering: (#topLeft).
	containerGC	 wrapDirection: (#none).
	containerGC	 frameFractions: (0@0 corner: 1@1).
	containerGC	 frameOffsets: (0@0 corner: 0@0).
	containerGC	 balloonText: (nil).
	containerGC	 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerGC	 color: (Color transparent).
	containerGC	 borderWidth: (0).
	containerGC	 borderStyle2: (#simple).
	containerGC	 borderColor: (Color black).
	containerGC	 setProperty: #objectName toValue: 'containerGC	'.
	containerGC	 setProperty: #objectDescription toValue: 'container for gc'.
	containerHeapGC addChild: containerGC	.
	unnamedMorph4 addChild: containerHeapGC.
	containerGraph := UiContainer new.
	containerGraph changeTableLayout.
	containerGraph extent: (276@314).
	containerGraph position: (472@120).
	containerGraph hResizing: (#spaceFill).
	containerGraph vResizing: (#spaceFill).
	containerGraph minWidth: (2).
	containerGraph minHeight: (2).
	containerGraph cellInset: (4).
	containerGraph cellPositioning: (#center).
	containerGraph cellSpacing: (#none).
	containerGraph layoutInset: (4).
	containerGraph listCentering: (#topLeft).
	containerGraph listDirection: (#topToBottom).
	containerGraph listSpacing: (#none).
	containerGraph maxCellSize: (1073741823).
	containerGraph minCellSize: (0).
	containerGraph wrapCentering: (#topLeft).
	containerGraph wrapDirection: (#none).
	containerGraph frameFractions: (0@0 corner: 1@1).
	containerGraph frameOffsets: (0@0 corner: 0@0).
	containerGraph balloonText: (nil).
	containerGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerGraph color: (Color lightGray).
	containerGraph borderWidth: (0).
	containerGraph borderStyle2: (#simple).
	containerGraph borderColor: (Color black).
	containerGraph setProperty: #objectName toValue: 'containerGraph'.
	scrollAreaGraph := ViScrollArea new.
	scrollAreaGraph extent: (268@306).
	scrollAreaGraph position: (476@124).
	scrollAreaGraph hResizing: (#spaceFill).
	scrollAreaGraph vResizing: (#spaceFill).
	scrollAreaGraph minWidth: (2).
	scrollAreaGraph minHeight: (2).
	scrollAreaGraph cellInset: (0).
	scrollAreaGraph cellPositioning: (#center).
	scrollAreaGraph cellSpacing: (#none).
	scrollAreaGraph layoutInset: (0).
	scrollAreaGraph listCentering: (#topLeft).
	scrollAreaGraph listDirection: (#topToBottom).
	scrollAreaGraph listSpacing: (#none).
	scrollAreaGraph maxCellSize: (1073741823).
	scrollAreaGraph minCellSize: (0).
	scrollAreaGraph wrapCentering: (#topLeft).
	scrollAreaGraph wrapDirection: (#none).
	scrollAreaGraph frameFractions: (0@0 corner: 1@1).
	scrollAreaGraph frameOffsets: (0@0 corner: 0@0).
	scrollAreaGraph balloonText: (nil).
	scrollAreaGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	scrollAreaGraph widgetResizable: (false).
	scrollAreaGraph horizontalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph verticalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph outerBorderWidth: (0).
	scrollAreaGraph scrollBarThickness: (9).
	scrollAreaGraph setProperty: #objectName toValue: 'scrollAreaGraph'.
	containerGraph addChild: scrollAreaGraph.
	unnamedMorph4 addChild: containerGraph.
	containerLegend := UiContainer new.
	containerLegend changeTableLayout.
	containerLegend extent: (276@20).
	containerLegend position: (472@438).
	containerLegend hResizing: (#spaceFill).
	containerLegend vResizing: (#rigid).
	containerLegend minWidth: (2).
	containerLegend minHeight: (2).
	containerLegend cellInset: (4).
	containerLegend cellPositioning: (#bottomRight).
	containerLegend cellSpacing: (#none).
	containerLegend layoutInset: (4).
	containerLegend listCentering: (#topLeft).
	containerLegend listDirection: (#rightToLeft).
	containerLegend listSpacing: (#none).
	containerLegend maxCellSize: (1073741823).
	containerLegend minCellSize: (0).
	containerLegend wrapCentering: (#topLeft).
	containerLegend wrapDirection: (#none).
	containerLegend frameFractions: (0@0 corner: 1@1).
	containerLegend frameOffsets: (0@0 corner: 0@0).
	containerLegend balloonText: (nil).
	containerLegend balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	containerLegend color: (Color transparent).
	containerLegend borderWidth: (0).
	containerLegend borderStyle2: (#simple).
	containerLegend borderColor: (Color black).
	containerLegend setProperty: #objectName toValue: 'containerLegend'.
	unnamedMorph4 addChild: containerLegend.
	panel addChild: unnamedMorph4.
	panel setProperty: #uiClassName toValue: 'AMMStudio'.! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.54'!
progressBar
	"No description given."
	
	^ progressBar! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.529'!
progressBarContainer
	"No description given."
	
	^ progressBarContainer! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.558'!
scrollAreaGraph
	"No description given."
	
	^ scrollAreaGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/18/2013 17:52:43.542'!
sourceCodeEdit
	"No description given."
	
	^ sourceCodeEdit! !

PasteUpMorph subclass: #AMMObjectsRepresentation
	instanceVariableNames: 'studio objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectsRepresentation subclass: #AMMHeap
	instanceVariableNames: 'heapCollection reservedCells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeap class methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 00:25:26.233'!
defaultSize
 
	^ 256! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:32:08.752'!
cellIsReservable: aCell

	^ ((aCell object isNil) and: ((self reservedCells indexOf: aCell) = 0))! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:37:37.479'!
clear

! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:40:58.621'!
clearHeap

	" remove all submorphs and empty all dictionaries/ collections"

	self removeAllMorphs.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/4/2013 10:15:46.844'!
createCells: amountOfCells

	"create entries for all objects"

	1 to: amountOfCells do: [ :cellNumber | 
		| cell |
		"self halt."
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (AMMHeapCell defaultWidth *(cellNumber-1)+self left) @ self top).
		cell lock.
		self addMorph: cell.
		self heapCollection add: cell.
	].
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/25/2013 23:16:15.121'!
freeAddressForSize: aSize
	| reseveredCells |
	reseveredCells := OrderedCollection new.

	self heapCollection doWithIndex: [:cell :index | 
		((index + aSize -1) > self heapCollection size) ifTrue: [ ^ nil].  
		(self cellIsReservable: cell)
			ifTrue: [ 
				reseveredCells add: cell.
				(1 to: (aSize-1)) do:[:i | | otherCell |
					otherCell := self heapCollection at: (index + i).
					(self cellIsReservable: otherCell) ifTrue: [ reseveredCells add: otherCell ].
					].
				(reseveredCells size = aSize ) 
					ifTrue:  [ self reservedCells addAll: reseveredCells.
								^ index]
					ifFalse: [ reseveredCells removeAll ]
			]
		].
	^ nil
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/17/2013 16:53:55.641'!
freeEmptiedCells
"	self halt."
	self submorphs do: [ :cell |
		(self objects includes: cell object) 
			ifFalse: [ cell object: nil ]	
		]! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:44.341'!
heapCollection
	
	 ^ heapCollection ifNil: [ heapCollection := OrderedCollection new ]! !

!AMMHeap methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:47:45.901'!
heapCollection: anObject

	heapCollection := anObject! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:59.241'!
heapSize

	^ self heapCollection size! !

!AMMHeap methodsFor: 'initialization' stamp: 'sw 6/3/2013 15:05:42.085'!
initialize 

	super initialize.
	
	self size: AMMHeap defaultSize.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:34:02.774'!
mapObjectsToHeap
	" iterates over objects and marks used heap cells "

	self objects do: [ :object |
			| cell |
			0 to: (object sizeOfObject - 1) do: [ :offset |
				(self heapCollection size >= (object address + offset)) ifTrue: [
					cell := self heapCollection at: (object address + offset). 
					cell object: object.
				]
			]
		].
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/10/2013 23:12:06.69'!
occupiedCells

	| occupiedCells |
	occupiedCells := 0.
	
	self heapCollection do: [ :cell | 
		(self cellIsReservable: cell) 
			ifFalse: [ occupiedCells := occupiedCells +1 ]].
	
	^ occupiedCells ! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/17/2013 13:59:51.23'!
render

	self freeEmptiedCells.
	self mapObjectsToHeap.
	self reservedCells removeAll.! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 6/7/2013 09:28:11.299'!
reservedCells

	^ reservedCells ifNil: [ reservedCells := OrderedCollection new ]! !

!AMMHeap methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 21:40:42.376'!
setAddressFor: metaObject

	| position |
	position := self freeAddressForSize: metaObject sizeOfObject.
	
	position ifNil: 
		[ ^ AMMHeapOutOfSpaceError signal: 'No space left for this object' ].
	metaObject address: position.
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/4/2013 10:15:02.428'!
size: aHeapSize

	self extent: ((AMMHeapCell defaultWidth * aHeapSize)@100);
		borderWidth: 0;
		color: Color transparent;
		heapCollection: OrderedCollection new.
		
	self clearHeap.
	self createCells: aHeapSize.
! !

AMMObjectsRepresentation subclass: #AMMObjectGraph
	instanceVariableNames: 'objectNodes layoutAlgorithm showReferenceCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/26/2013 00:48:31.925'!
addNewNodes
"Create one ObjectNode for every new object and register the morph in the temporary storage"
| newObjects |
	newObjects := self objects select: [:obj | (self objectNodes includesKey: obj) not ] .	

	newObjects do:[ :obj |
		|node|
				node := AMMObjectNode new.
				self addMorph: node.
				node object: obj.
				self objectNodes at: obj put: node.
		].

	^ newObjects
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'ci 6/16/2013 18:27:26.421'!
calculatePositionFor: anObject objects: anOrderedCollectionOfObjects
	| roots position |
	
	position := 0@0.
	roots :=  anOrderedCollectionOfObjects select: [:object | object isRoot].
	
	(anObject isRoot) 
		ifTrue: [ position := ((roots size - 1) * (80@0) + (40@40)) ]
		ifFalse: [
			"todo: find its root, its level, and the number of siblings on this level."
			position := (80@80)
		].
	
	^ position
	
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:16:38.383'!
clear

	self layoutAlgorithm delete.
	self removeNodes.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:40:23.524'!
connectNode: node with: anotherNode

	| connection |
	connection := NCAAConnectorMorph fromMorph: node toMorph: anotherNode.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/12/2013 00:33:26.032'!
connectNode: node with: anotherNode labeled: aLabel

	| connection |
	connection := AMMConnectorMorph fromMorph: node toMorph: anotherNode.
	connection label: aLabel.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:17:54.791'!
connectNodes

	self objectNodes keysAndValuesDo:[ :metaObject :node |
		node removeUnreferencedConnectors.

		metaObject references do: [ :referencedMetaObject |
			node connectedNodes 
				detect: [:otherNode | (otherNode object = referencedMetaObject) ]
				ifNone: [ | label | 
					label := metaObject refenceNameOf: referencedMetaObject.
					self connectNode: node with: (self objectNodes at: referencedMetaObject) labeled: label ].
		] 
	]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:10:01.767'!
connectNodes: anCollection

	anCollection 
		do:[ :node|
			self connectReferences: node. 
		]! !

!AMMObjectGraph methodsFor: 'submorphs-add/remove' stamp: 'sw 5/6/2013 19:48:36.428'!
delete

	self clear.
	super delete.! !

!AMMObjectGraph methodsFor: 'initialization' stamp: 'sw 6/17/2013 16:06:39.915'!
initialize 

	super initialize.
	self 
		extent: 2000@1000;
		color: Color transparent;
	 	borderWidth: 0.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 13:40:23.548'!
layoutAlgorithm

	^ layoutAlgorithm ifNil: [ layoutAlgorithm := AMMGraphLayoutAlgorithm new.]
! !

!AMMObjectGraph methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:19:31.235'!
layoutAlgorithm: anObject

	layoutAlgorithm := anObject! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:20.328'!
layoutNodes
	WorldState
		addDeferredUIMessage: 
[ self layoutAlgorithm layoutMorph: self]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/20/2013 23:24:10.656'!
objectNodes

	^ objectNodes ifNil: [ objectNodes := IdentityDictionary new.]! !

!AMMObjectGraph methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:19:31.232'!
objectNodes: anObject

	objectNodes := anObject! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/20/2013 23:19:05.964'!
removeNodes 

	self removeAllMorphs.
	Transcript show: 'remove Nodes!!!!!!'.
	self objectNodes keysDo: [:key | self objectNodes removeKey: key ]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:49:50.223'!
removeNodesOfDeletedObjects
	"self halt."
	self objectNodes values do: [ :node |
		(self objects includes: node object) 
			ifFalse: [ node  delete ]	
		]
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 19:18:33.912'!
render

	| newNodes |
	
	self removeNodesOfDeletedObjects.
	newNodes := self addNewNodes.
	
	self connectNodes.

	self layoutNodes.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:41:50.661'!
runGraph

	WorldState
		addDeferredUIMessage: [self layoutAlgorithm layoutMorph: self]
layoutNodes

	"move nodes"! !

!AMMObjectGraph methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:49:44.852'!
showReferenceCount

	^ showReferenceCount ifNil: [ showReferenceCount := true ]! !

!AMMObjectGraph methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:19:31.24'!
showReferenceCount: anObject

	showReferenceCount := anObject! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:01:46.883'!
activeColor
	^ Color green! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 14:13:15.91'!
defaultBorderColor

	^ Color blue.
	
! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 14:01:44.172'!
defaultBorderColorIfRoot

	^ Color red.
	
! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 14:01:48.016'!
defaultBorderColorOnHover 

	^ Color orange.
	
! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 14:01:52.225'!
defaultBorderWidth 

	^ 3! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:14:29.41'!
defaultColor
	^ Color white! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:05:39.145'!
emptyColor
	^ (Color r: 0.8 g: 0.8 b: 0.8)! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:13:59.975'!
markedColor
	^ Color green! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:14:20.128'!
occupiedColor
	^ Color blue! !

!AMMObjectsRepresentation class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:14:12.856'!
visitedColor
	^ Color lightGreen! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:57.498'!
clear
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 6/4/2013 17:45:44.97'!
objects

	^ objects ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:07:21.553'!
objects: anObject

	self clear.

	objects := anObject.

	self render.! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:07:40.779'!
refresh

	self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 09:46:42.197'!
render
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.769'!
studio

	^ studio! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.78'!
studio: anObject

	studio := anObject! !

PasteUpMorph subclass: #AMMProgressBar
	instanceVariableNames: 'value maxValue progressBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMProgressBar methodsFor: 'as yet unclassified' stamp: 'ci 6/25/2013 19:39:28.203'!
initialize 

	super initialize.
	
	self extent: (340@20).
	self borderWidth: 1.
	self borderColor: Color black.

	self progressBar: RectangleMorph new.
	self progressBar extent: (0@20).
	self progressBar color: (Color r:0.02 g:0.21 b:0.42).
	self progressBar borderWidth: 0.
	self addMorph: (self progressBar).! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:33:38.731'!
maxValue

	^ maxValue ifNil: [maxValue := 1]! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:22:09.762'!
maxValue: anObject

	maxValue := anObject! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:29:46.053'!
progressBar

	^ progressBar! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:29:46.063'!
progressBar: anObject

	progressBar := anObject! !

!AMMProgressBar methodsFor: 'as yet unclassified' stamp: 'rm 6/10/2013 13:32:06.945'!
update 

	self progressBar extent: ((340 * self value / self maxValue)@20).! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:34:43.251'!
value

	^value ifNil: [value := 0]! !

!AMMProgressBar methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:37:56.482'!
value: anObject
	
	(anObject > self maxValue) 
		ifTrue: [value := self maxValue]
		ifFalse: [	value := anObject].
	self update.! !

NCSimulatedAnnealingGraphLayoutAlgorithm subclass: #AMMGraphLayoutAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.774'!
aeMinEdgeLength
	"sw: I had to change this, hence errors came up, after removing the PasteUpMorph, although the layout algorithm is still active."
	
	"I am an aesthetic that causes edges to be shortened. My magnitude is d^2, where d is the magnitude of the distance between nodes. Since I consider all edges, my time complexity is O(|E|)"

	| retval |
	retval := IdentityDictionary 
				newFrom: (self nodes collect: [:node | node -> (0 @ 0)]).
	self edges do: 
			[:edge | 
			| fromNode toNode delta mag force |
			fromNode := edge startConnection.
			toNode := edge endConnection.
			((fromNode isNil) or: toNode isNil) ifFalse: [
				delta := toNode center - fromNode center.
				delta := delta / scale.
				mag := delta r.
				force := mag * delta.
				retval at: fromNode put: (retval at: fromNode) + force.
				retval at: toNode put: (retval at: toNode) - force].
			].	

   ^self nodes collect: [:ea | retval at: ea]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.784'!
aeNodeRepulsion
	"I am an aesthetic that attempts to keep nodes apart. My magnitude is 1/d^2, where d is the magnitude of the distance between nodes. Since I consider all node combinations, my time complexity is O(|V|^2)"

	| retval |
	retval := Array new: self nodes size withAll: 0.0 @ 0.0.
	(1 to: self nodes size) combinations: 2
		atATimeDo: 
			[:arr | 
			| ai1 ai2 node otherNode delta mag2 force |
			 "self halt."
			node := self nodes at: (ai1 := arr at: 1).
			otherNode := self nodes at: (ai2 := arr at: 2).
			delta := (node center - otherNode center) asFloatPoint.
			delta := (delta / scale) + 0.001.
			mag2 := delta x * delta x + (delta y * delta y) max: 1.0e-8.
			force := 1.0 / mag2 * delta.
			retval at: ai1 put: (retval at: ai1) + force.
			retval at: ai2 put: (retval at: ai2) - force].
	^retval! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 19:00:03.683'!
arrangeSubtreeOf: metaObj withNodes: nodesDictionary traversed: aCollection offsetLeft: anOffsetLeft depth: aDepth

	
	| offset width |
	((aCollection indexOf: metaObj) > 0) ifTrue: [ ^ 0 ].
	offset := anOffsetLeft.
	
	aCollection add: metaObj.
	
	metaObj references do: [:referencedObj | | widthOfReferencedObj |	
		widthOfReferencedObj := self arrangeSubtreeOf: referencedObj withNodes: nodesDictionary traversed: aCollection offsetLeft: offset depth: (aDepth+1).
		offset := offset + widthOfReferencedObj.		
	].

	width := offset - anOffsetLeft.
	(width = 0) ifTrue: [
			width := AMMObjectNode defaultOffset.
		].
	
	(nodesDictionary at: metaObj) position: (anOffsetLeft + (width/2))@(aDepth *60).
	^ width
! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 16:02:42.912'!
layoutMorph: aPasteUpMorph 
	"aPastUpMorph is e.g. AMMObjectGraph the nodes are in .objects"

	self preArrangeConnectedMorphs: aPasteUpMorph.
! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 16:02:39.358'!
preArrangeConnectedMorphs: aPasteUpMorph
	"ci: a first implementation.
	the algorithm of the future:
		all roots do:
			collect levels and number of nodes on each level.
			maxLevelNodes = maximum number of nodes per level.
			maxWidth = cDistance (class constant) * maxLevelNodes.
			xDistance per level = maxWidth/ levelNodes.
			parameters: offset, return value: new offset
	"
	|   offset positionedObjectNodes |
	
	positionedObjectNodes := OrderedCollection new.
	"roots := aPasteUpMorph objects select: [:metaObj | metaObj isRoot ]."
	offset := 0@20.


	aPasteUpMorph objects doWithIndex: [:metaObj :index |  | width |	
		width := self arrangeSubtreeOf: metaObj withNodes: (aPasteUpMorph objectNodes) traversed: positionedObjectNodes offsetLeft:(offset x) depth: 1.
		offset := offset + (width@0).
	].


	! !

UiTextMorph subclass: #AMMSourceCodeTextMorph
	instanceVariableNames: 'returnCount previousTextEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeTextMorph methodsFor: 'private' stamp: 'sw 6/1/2013 10:53:14.215'!
editorClass

	^ AMMSourceCodeEditor
! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.114'!
explorerRequested: anObject

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/2/2013 20:52:37.453'!
expressionEvaluated: result

	^ self emitInOwnerChain! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.13'!
implementorsRequested: aSelector

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'initialization' stamp: 'sw 6/1/2013 10:47:13.159'!
initialize

	super initialize.
	returnCount := 0.
	previousTextEnd := 0.! !

!AMMSourceCodeTextMorph methodsFor: 'event handling' stamp: 'sw 6/1/2013 10:47:13.166'!
keyStroke: aKeyboardEvent

	returnCount == 0 ifTrue: [previousTextEnd := text size + 1].

	super keyStroke: aKeyboardEvent.
	
	self readOnly ifTrue: [^ self].
	
	(({Character lf. Character cr. Character enter} includes: aKeyboardEvent keyCharacter)
		and: [self editor startIndex == (text size + 1)])
		ifTrue: [returnCount := returnCount + 1]
		ifFalse: [returnCount := 0].
		
	returnCount >= 2
		ifTrue: [self repeatedReturnPressed: returnCount].! !

!AMMSourceCodeTextMorph methodsFor: 'event handling' stamp: 'sw 6/1/2013 10:47:13.18'!
mouseUp: evt

	super mouseUp: evt.
	
	self showContextMenu: evt.! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.138'!
queryRequested: anObject

	self emitInOwnerChain.  ! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.145'!
repeatedReturnPressed: count

	self emit.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.188'!
requestExplorer: anObject

	self explorerRequested: anObject.  ! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.195'!
requestImplementors: aLiteral

	self implementorsRequested: aLiteral.  ! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.202'!
requestQuery: anObject

	self queryRequested: anObject.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.209'!
requestSenders: aLiteral

	self sendersRequested: aLiteral.  ! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.152'!
sendersRequested: aSelector

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.216'!
showContextMenu: aMouseEvent

	| menu |
	self selection ifEmpty: [^ self].
	
	menu := ViContextMenu new.
	
	"Connect back to editor to make source code more readable."
	menu
		addIcon: UiFugueIcons folderOpenDocumentTextIcon text: 'Open it (CMD+O)' receiver: self editor selector: #openIt;
		addSeparator;
		addIcon: UiSilkIcons cogIcon text: 'Do it (CMD+D)' receiver: self editor selector: #doIt;
		addIcon: UiSilkIcons printerIcon text: 'Print it (CMD+P)' receiver: self editor selector: #doIt;
		addIcon: UiFugueIcons magnifierIcon text: 'Explore it (CMD+I)' receiver: self editor selector: #exploreIt;
		addIcon: UiFugueIcons documentTreeIcon text: 'Browse it (CMD+B)' receiver: self editor selector: #browseIt;
		addSeparator;
		addIcon: UiFugueIcons arrowStepIcon text: 'Senders of it (CMD+N)' receiver: self editor selector: #sendersOfIt;
		addIcon: UiFugueIcons scriptsTextIcon text: 'Implementors of it (CMD+M)' receiver: self editor selector: #implementorsOfIt.
	
	menu popUpAt: (self pointInWorld: aMouseEvent position).! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.229'!
undoRepeatedReturnPress

	returnCount := 0.
	self selectionChanged.
	self editor backTo: previousTextEnd.
	self updateFromParagraph.! !

UiTextMorph subclass: #AMMTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:45:40.6'!
editorClass

	^ AMMTextEditor! !

Morph subclass: #AMMStudio
	instanceVariableNames: 'ui heap objectgraph gc currentUnit currentApplication historyManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 16:01:38.96'!
open

	^ self new openInWindowLabeled: 'AMM Studio'.! !

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 12:52:46.964'!
setUp

	AMMSourceCodeEditor initialize.
	AMMMetaObject reset.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/4/2013 09:41:26.994'!
bindingFor: anObject

	self bindings keysAndValuesDo: [:key :value | 
		(value = anObject ) ifTrue: [ ^ key ]
		].
	^ nil! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/4/2013 09:37:29.519'!
bindings 

	^ self ui sourceCodeEdit model bindings ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/3/2013 14:48:07.314'!
currentApplication

	^ currentApplication! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/3/2013 14:48:07.317'!
currentApplication: anObject

	currentApplication := anObject! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:48:54.013'!
currentUnit

	^ currentUnit! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:49:15.468'!
currentUnit: anAMMUnit

	currentUnit := anAMMUnit! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/19/2013 09:49:53.379'!
disablePlayControls

	World stopStepping: self.
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/19/2013 08:19:27.853'!
enablePlayControls

"	self ui buttonPause enabled: false.	
	self ui buttonStep enabled: true.		
	self ui buttonPlay enabled: true.		"! !

!AMMStudio methodsFor: 'accessing' stamp: 'rm 6/2/2013 16:57:34.648'!
gc

	^ gc! !

!AMMStudio methodsFor: 'accessing' stamp: 'rm 6/2/2013 16:57:31.198'!
gc: aGarbageCollector

	gc := aGarbageCollector! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/17/2013 16:28:12.412'!
gcStep

	self gc gcStep.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:43:28.137'!
handleEventDisableNextButton

	self ui buttonNext enabled: false.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:10:29.183'!
handleEventEnableNextButton

	self ui buttonNext enabled: true.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'ci 6/23/2013 11:42:49.139'!
handleEventErrorOccured: anErrorMessage
	
	| tPosition |
	tPosition := (self ui sourceCodeEdit extent)/2 + (self ui sourceCodeEdit position).
	UserDialogBoxMorph 
		inform: anErrorMessage 
		title: 'Error' 
		at: tPosition.
		
	"self ui sourceCodeEdit textMorph editor afterSelectionInsertAndSelect: anErrorMessage."! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:09:37.19'!
handleEventMakeObjectReachable: anObject withLabel: aLabel
	"Put the object into the binding dictionary of the workspace model - if it isn't there already. "

	(self bindingFor: anObject = aLabel) 
		ifTrue: [ ^ self ].
	self bindings at: aLabel put: anObject.
! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/18/2013 17:30:49.95'!
handleEventRefreshView

	self refreshObjectRepresentations.
	! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/24/2013 15:23:46.478'!
handleEventReplaceObjects: aCollection
	
	self currentApplication metaObjects: aCollection.
	self objectgraph objects: aCollection.	
	self heap objects: aCollection.

	self gc objects: aCollection.
	
	self refreshObjectRepresentations.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:08:12.082'!
handleEventSetGCAlgorithm: anAlgorithm

	self gc algorithm: anAlgorithm! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:47:50.59'!
handleEventShowMessage: aMessage

	self ui sourceCodeEdit theText: aMessage ! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/17/2013 16:09:37.032'!
handleEventSourceCodeExecuted: aResult
	| selectedCode |
	
	selectedCode := self ui sourceCodeEdit textMorph selection.
	
	self currentApplication setReachableObjectsAsRoot: self bindings.
	 
	self currentUnit sourceCodeExecuted: selectedCode withBindings: self bindings withResult: aResult.
	
	self refreshObjectRepresentations.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:50:56.739'!
handleEventStoreObjectInMemory: anObject 

	self currentApplication addObject: anObject! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/20/2013 20:19:14.147'!
handleEventUnitFinished

	"self startNextUnit."
	! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/19/2013 09:13:15.357'!
handleStartAutoplay
	
	" trigger frequently step method "
	
	World
		startStepping: self
		at: Time millisecondClockValue
		selector: #gcStep
		arguments: { }
		stepTime: 1000.
! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/19/2013 09:12:13.539'!
handleStopAutoplay

	World stopStepping: self.
! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:53:16.717'!
heap

	^ heap! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:54:09.601'!
heap: aHeap

	heap := aHeap! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/20/2013 20:12:35.214'!
historyManager

	^ historyManager! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/20/2013 20:12:35.239'!
historyManager: anObject

	historyManager := anObject! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 6/20/2013 20:13:04.613'!
initialize 

	super initialize.
	self ui setupUi: self.

	self extent:800@500.
	
	self historyManager: AMMHistoryManager new.
	
	self initializeUnits.
	self initializeGraphicalRepresentations.	
	self initializeLegend.


	self startUnit: AMMUnitExplorative new.
	
	self registerSignalsForGeneralControls.
	
! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 6/17/2013 16:05:28.061'!
initializeGraphicalRepresentations

	self heap: (AMMHeap new).
	self ui containerHeap addMorph: self heap.
	
	self gc: (AMMGarbageCollector new).
	self ui containerGC addMorph: self gc.
	
	self objectgraph: (AMMObjectGraph new).
	self ui scrollAreaGraph widget: self objectgraph.
	
! !

!AMMStudio methodsFor: 'initialization' stamp: 'rm 6/19/2013 20:22:13.541'!
initializeLegend
	
	| tmp |
	tmp := RectangleMorph new.
	tmp borderWidth: 2;
		extent: (10@10);
		color: AMMObjectsRepresentation  defaultColor;
		borderColor: AMMObjectsRepresentation defaultBorderColor .
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'object').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 2;
		extent: (10@10);
		color: AMMObjectsRepresentation  defaultColor;
		borderColor: AMMObjectsRepresentation defaultBorderColorIfRoot .
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'root').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 2;
		extent: (10@10);
		color: AMMObjectsRepresentation  defaultColor;
		borderColor: AMMObjectsRepresentation defaultBorderColorOnHover.
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'hovered').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 0;
		extent: (10@10);
		color: AMMObjectsRepresentation markedColor.
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'marked').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 0;
		extent: (10@10);
		color: AMMObjectsRepresentation visitedColor.
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'visited').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 0;
		extent: (10@10);
		color: AMMObjectsRepresentation emptyColor.
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'empty').
	
	tmp := RectangleMorph new.
	tmp borderWidth: 0;
		extent: (10@10);
		color: AMMObjectsRepresentation occupiedColor.
	self ui containerLegend addMorph: (tmp).
	self ui containerLegend addMorph: (StringMorph contents: 'occupied').
	! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 5/16/2013 11:13:11.437'!
initializeUnits
	
	|subclasses|
	
	subclasses := AMMUnit allSubclasses.
	subclasses sort: [ :classA :classB | classA name asString < classB name asString ].
	self ui comboUnits 
		addItemListFrom: subclasses
		using: [:unit :listItem | 
			listItem text: unit nameOfUnit. 
			listItem data: unit. ].
		
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/20/2013 20:14:58.06'!
next

	self halt. " lets see, whether this is used at all ;-) "

	(self currentUnit isNil) 
		ifFalse: [ self currentUnit next ]! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/20/2013 20:15:14.071'!
nextSequence

	self historyManager next.
	
	self currentUnit next.
	self updateProgressBar! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:00:51.495'!
objectgraph

	^ objectgraph ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:01:26.257'!
objectgraph: anObjectgraph

	objectgraph := anObjectgraph! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/20/2013 20:15:29.577'!
previousSequence

	self historyManager previous.
	
	self currentUnit previous.
	self updateProgressBar! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/25/2013 19:12:07.046'!
refreshObjectRepresentations

	self objectgraph render.
	self heap render.
! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/17/2013 14:05:32.139'!
registerSignalsForCurrentApplication

	self connect: self currentApplication signal: #errorOccured: toSelector: #handleEventErrorOccured: pattern: #(1).

! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/19/2013 09:22:59.811'!
registerSignalsForCurrentUnit

	self connect: self currentUnit signal: #showMessage: toSelector: #handleEventShowMessage: pattern: #(1).
	
	self connect: self currentUnit signal: #stopAutoplay toSelector: #handleStopAutoplay.
	self connect: self currentUnit signal: #startAutoplay toSelector: #handleStartAutoplay.
	
	
	self connect: self currentUnit signal: #finished toSelector: #handleEventUnitFinished.

	self connect: self currentUnit signal: #enableNextButton toSelector: #handleEventEnableNextButton.
	self connect: self currentUnit signal: #disableNextButton toSelector: #handleEventDisableNextButton.
	
	self connect: self currentUnit signal: #setGCAlgorithm: toSelector: #handleEventSetGCAlgorithm: pattern: #(1).
	
	self connect: self currentUnit signal: #storeObjectInMemory: toSelector: #handleEventStoreObjectInMemory: pattern:#(1).
	self connect: self currentUnit signal: #makeObjectReachable:withLabel: toSelector: #handleEventMakeObjectReachable:withLabel:  pattern:#(1 2).
! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/20/2013 22:00:45.508'!
registerSignalsForGeneralControls

	self connect: self ui buttonNext signal:#clicked: toSelector: #nextSequence.
	self connect: self ui buttonPrevious signal:#clicked: toSelector: #previousSequence.
	self connect: self ui comboUnits signal: #currentTextChanged: toSelector: #selectUnit.
	

	self connect: self historyManager signal: #replaceObjects: toSelector: #handleEventReplaceObjects: pattern:#(1).

	
	" submorph (AMMSourceCodeTextMorph) emits signal and forwards it via all owner morphs - use of vivide-signals ;-("	
	self sgConnectSignal: #expressionEvaluated: toSelector:  #handleEventSourceCodeExecuted: pattern: #(1).
	
	self sgConnectSignal: #startAutoplay toSelector:  #handleStartAutoplay.
	self sgConnectSignal: #stopAutoplay toSelector:  #handleStopAutoplay.
	self sgConnectSignal: #refreshView toSelector:  #handleEventRefreshView.
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/16/2013 11:31:34.541'!
selectUnit

	self startUnit: (self ui comboUnits currentItem data new).! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/24/2013 15:33:34.497'!
setUpNewApplication

	| app |
	
	self unregisterSignalsForCurrentApplication.	

	self gc algorithm: nil.
	app :=  AMMApplication new
		heap: self heap;
		garbageCollector: self gc.

	self historyManager application: app.
	
	self objectgraph objects: app metaObjects.
	self heap objects: app metaObjects.	
	
	self ui sourceCodeEdit model bindings at: 'app' put: app.
		
	self currentApplication: app.
	self registerSignalsForCurrentApplication.
	
	! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/10/2013 11:58:58.265'!
setUpNewUnit: anUnit
	
	self unregisterSignalsForCurrentUnit.	
	self currentUnit: anUnit.
	
	self registerSignalsForCurrentUnit.

	self currentUnit next.! !

!AMMStudio methodsFor: 'processing-units' stamp: 'rm 6/19/2013 21:32:12.545'!
startNextUnit

	self ui comboUnits currentIndex: (self ui comboUnits currentIndex +1).
	! !

!AMMStudio methodsFor: 'processing-units' stamp: 'rm 6/19/2013 21:32:20.594'!
startUnit: anUnit

	
	self setUpNewApplication.
	
	self setUpNewUnit: anUnit.
	
	self updateProgressBar.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 4/29/2013 12:05:54.615'!
ui
	
	^ ui ifNil: [ ui:= AMMStudioUi new ]! !

!AMMStudio methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:44:40.556'!
ui: anObject

	ui := anObject! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/11/2013 10:13:49.573'!
unregisterSignalsForCurrentApplication

	(self currentApplication isNil) 
		ifFalse: [
			self disconnectSignal: #objectChanged from: self currentApplication.
			self disconnectSignal: #errorOccured: from: self currentApplication.
		]
	! !

!AMMStudio methodsFor: 'events-listening' stamp: 'rm 6/16/2013 14:56:13.329'!
unregisterSignalsForCurrentUnit

	(self currentUnit isNil) 
		ifFalse: [ 
			"self currentUnit objects 
				do:[ :obj | 
					self disconnectSignal: #changed from: obj.
				]."
			self disconnectSignal: #showMessage: from: self currentUnit.
			self disconnectSignal: #finished  from: self currentUnit.
			self disconnectSignal: #stopAutoplay from: self currentUnit.
			self disconnectSignal: #startAutoplay from: self currentUnit.

			self disconnectSignal: #enableNextButton from: self currentUnit.
			self disconnectSignal: #disableNextButton from: self currentUnit.

			self disconnectSignal: #objectsChanged from: self currentUnit.

		].


! !

!AMMStudio methodsFor: 'processing-units' stamp: 'rm 6/19/2013 20:43:00.397'!
updateProgressBar 

	self ui progressBar maxValue: self currentUnit getSequenceCount.
	self ui progressBar value: self currentUnit currentSequence.! !

Error subclass: #AMMMemoryError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMemoryError subclass: #AMMHeapOutOfSpaceError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMemoryError subclass: #AMMObjectIsNotExtended
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:16:13.633'!
at: key put: anObject 
	(self includesKey: key) 
		ifFalse: [
		self orderedKeys add: key.
		].
	super at: key put: anObject.
	! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:17:21.275'!
removeKey: key 

	self orderedKeys remove: key.
	^ super removeKey: key.	
! !

TestCase subclass: #AMMApplicationTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 13:45:59.44'!
setUp 

	sut := AMMApplication new.
	sut heap: AMMHeap new.
	sut heap objects: sut metaObjects.! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 17:51:51.478'!
test10AddObjectAddsObjectsRecursive
	
	| advObj simObj |
	self assert: sut metaObjects isEmpty.
	
	advObj :=AMMMetaObjectAdvancedExample new.
	simObj := AMMMetaObjectSimpleExample new.
	
	advObj otherObject: simObj.
	
	sut addObject: advObj.
	
	self assert: ((sut metaObjects indexOf: (AMMMetaObject for: simObj)) > 0 ).! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 23:15:16.093'!
test11AddObjectAddsObjectsRecursiveOnLaterChanges
	
	| advObj simObj |
	self assert: sut metaObjects isEmpty.
	
	advObj :=AMMMetaObjectAdvancedExample new.
	simObj := AMMMetaObjectSimpleExample new.
	
	sut addObject: advObj.
	
	advObj otherObject: simObj.
	
	self assert: ((sut metaObjects indexOf: (AMMMetaObject for: simObj)) > 0 ).! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 17:51:57.286'!
test20CannotAddUnextendedOrderedCollection
	
	| error |
	
	[ sut addObject: OrderedCollection new ] on: AMMObjectIsNotExtended do: [ :e | error:= e].

	self assert: error notNil.
	
	! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 23:12:26.195'!
test30AddObjectAddsAnAnonymObject
	
	| advObj size |
	self assert: sut metaObjects isEmpty.

	self assert: (sut heap occupiedCells = 0 ).
	
	advObj :=AMMMetaObjectAdvancedExample new.
	advObj otherObject: AMMMetaObjectSimpleExample new.
	
	sut addObject: advObj.
	
	self assert:  (sut metaObjects size = 2).
	
	size := (AMMMetaObject for: advObj) sizeOfObject.
	size := size + (AMMMetaObject for: (advObj otherObject)) sizeOfObject.
	
	self assert: size = (sut heap occupiedCells).! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 23:06:04.495'!
test40ImageFreezeOnDoupleDispatch
	| paul |

	paul := AMMHuman new.
	paul name: 'Paul'.
	paul father: AMMHuman new.
	paul father name: 'Peter'.
	sut addObject: paul.
	self deny: sut metaObjects isEmpty.
	paul father father: paul.
	self assert: sut metaObjects size = 2.
! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 23:01:48.325'!
test50AddObjectToFullHeapRejectsAdding
	
	sut heap size:0.
	[ sut addObject: AMMMetaObjectSimpleExample new ] on: Exception do: [:e | ].
	self assert: sut metaObjects isEmpty.
	! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 23:05:55.444'!
test51AddObjectToFullHeapThrowsException
	
	| exception |
	sut heap size:0.
	[ sut addMetaObject: (AMMMetaObject for: AMMMetaObjectSimpleExample new) ] on: Exception do: [:e | exception :=e ].
	self assert: exception notNil.
	! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 23:12:03.867'!
test55AddReferencedObjectToFullHeapRejectsAdding
	
	| exception obj otherObject |
	obj := AMMMetaObjectAdvancedExample new.	
	sut heap size: ((AMMMetaObject for: obj) sizeOfObject).
	sut addObject: obj.
	
	otherObject := AMMMetaObjectSimpleExample new.
	
	[ obj otherObject: otherObject ] on: Exception do: [:e | exception :=e ].
	self assert: (sut metaObjects size = 1).
	! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 23:17:57.591'!
test56AddReferencedObjectToFullHeapThrowsException
	
	| exception obj otherObject |
	obj := AMMMetaObjectAdvancedExample new.	
	sut heap size: ((AMMMetaObject for: obj) sizeOfObject).
	sut addObject: obj.
	
	otherObject := AMMMetaObjectSimpleExample new.
	
	[ obj otherObject: otherObject ] on: Exception do: [:e | exception :=e ].
	self deny: exception isNil.
	! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/26/2013 00:11:02.707'!
test57AddReferencedObjectToFullHeapSetsReferenceToNil
	
	| obj otherObject exception |
	obj := AMMMetaObjectAdvancedExample new.	
	sut heap size: ((AMMMetaObject for: obj) sizeOfObject).
	sut addObject: obj.
	
	otherObject := AMMMetaObjectSimpleExample new.	
	"	obj otherObject: otherObject."
	[ obj otherObject: otherObject ] on: Exception do: [:e | exception :=e ].
	self assert: obj otherObject isNil.
	! !

TestCase subclass: #AMMGCAlgorithmTest
	instanceVariableNames: 'sut app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:33:38.492'!
addObjectsWithOrphan
	
| objB objA objC |
	
	objA := AMMMetaObjectAdvancedExample new.
	objB := AMMMetaObjectSimpleExample new.
	objC := AMMMetaObjectSimpleExample new.
	(AMMMetaObject for: objA) name: 'a'.
	objA otherObject: objB.
	
	app addObject: objA;
		addObject: objC.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:33:59.82'!
addReachableExampleObjects
	
| objB objC objD |
	objB := AMMMetaObjectSimpleExample new.
	objC := AMMMetaObjectSimpleExample new.
	objD := AMMMetaObjectSimpleExample new.

	(AMMMetaObject for: objB) name: 'a'.
	(AMMMetaObject for: objC) name: 'b'.
	(AMMMetaObject for: objD) name: 'c'.


	app addObject: objB; 
		addObject: objC;
		addObject: objD.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:34:09.044'!
addReachableExampleObjectsWithOneChild
	
| objB objA |
	objA := AMMMetaObjectAdvancedExample new.
	objB := AMMMetaObjectSimpleExample new.

	(AMMMetaObject for: objA) name:'a'.
	objA otherObject: objB.

	app addObject: objA.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 11:34:24.086'!
addReachableExampleObjectsWithOneChildAndFurtherReachables
	
| objB objA objC |
	objA := AMMMetaObjectAdvancedExample new.
	objB := AMMMetaObjectSimpleExample new.
	objC := AMMMetaObjectSimpleExample new.
	(AMMMetaObject for: objA) name:'a'.
	objA otherObject: objB.
	(AMMMetaObject for: objC) name:'b'.

	app addObject: objA;
		addObject: objC.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:23:48.189'!
addUnreachableExampleObjects
	
| objB objC objD |
	objB := AMMMetaObjectSimpleExample new.
	objC := AMMMetaObjectSimpleExample new.
	objD := AMMMetaObjectSimpleExample new.


	app addObject: objB; 
		addObject: objC;
		addObject: objD.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:22:48.891'!
setUp 

	sut := AMMGCAlgorithm new.
	app := AMMApplication new.
	app heap: AMMHeap new.

	sut objects: app metaObjects.
	! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:43:40.012'!
test001FirstVisitedObjectGetsEntered

	| obj |
	self addReachableExampleObjectsWithOneChild.
	
	obj := sut nextObject. 
	
	self assert: (obj == (sut objects at:1)).
	self assert: (obj flag == #activeTraversal).

	" first object is in the stack "
	self assert: ((sut objectStack orderedKeys last) == obj).
	
	" children counter is zero "
	self assert: ((sut objectStack at: obj) == 0).
	! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:25:04.22'!
test009ReturnsOnlyRootNodes

	| objA |
	self addUnreachableExampleObjects.
	self deny: sut objects isEmpty.
	
	objA := sut nextObject. 
	
	self assert: (objA isNil).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:29:40.696'!
test010ReturnAllRootNodes

	| objA objB |
	objB := nil.
	self addReachableExampleObjects.
	self deny: (sut objects isNil).
	sut objects doWithIndex: [:obj :i |
		self assert: (obj isRoot).
		objA := sut nextObject. 
		self assert: (obj = objA).
		self assert: (objA flag = #activeTraversal). " state is changed "
		objB ifNotNil:[ self assert:  (objB flag = #doneTraversal).]. " state is changed back"
		objB := objA.
		].
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:35:13.84'!
test015EnterChildOfFirstNode

	| objA objB rootNode childNode |
	self addReachableExampleObjectsWithOneChild.
	
	rootNode := sut nextObject. 
	
	self assert: (rootNode == (sut objects at:1)).	
	self assert: (rootNode flag = #activeTraversal). " state is changed "
	
	self assert: ((rootNode references at:1) flag = #new). " untraversed child has the state new"
	
	childNode := sut nextObject. 
	
	self assert: (rootNode flag = #activeTraversal). " state is still active "
	
	self assert: (childNode == (rootNode references at:1)).

	self assert: (childNode flag = #activeTraversal).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:39:59.51'!
test015TicReturnToParentNodeAndContinue

	| objA objB objC |
	self addReachableExampleObjectsWithOneChild.
	
	objA := sut nextObject. 
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objB flag = #activeTraversal).
	
	objC := sut nextObject. 
	
	self assert: (objC isNil).
	
	self assert: (objA flag = #doneTraversal). " state is left "
	self assert: (objB flag = #doneTraversal). " state is left "! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:38:09.316'!
test016EnterChildOfFirstAndReturn

	| rootNode childNode independentNode |
	self addReachableExampleObjectsWithOneChildAndFurtherReachables.
	
	rootNode := sut nextObject. 
	
	self assert: (rootNode flag = #activeTraversal). " state is changed "
	
	childNode := sut nextObject. 
	
	self assert: (rootNode flag = #activeTraversal). 
	self assert: (childNode flag = #activeTraversal).
	
	self assert: (childNode == (rootNode references at:1)).

	independentNode := sut nextObject.
	self assert: (rootNode flag = #doneTraversal). 
	self assert: (childNode flag = #doneTraversal).
	self assert: (independentNode flag = #activeTraversal).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:45:46.149'!
test020EnterTwoRoots

	| objA objB |
	self addReachableExampleObjects.
	
	objA := sut nextObject. 
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).
	self assert: (objB flag = #activeTraversal).

	self assert: (objA flag = #doneTraversal). " state is still active "
	

	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 11:42:54.968'!
test030DoNotVisitOrphanObject

	| objA objB objC |
	self addObjectsWithOrphan.
	
	objA := sut nextObject. 
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).

	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

TestCase subclass: #AMMMetaObjectReferencesTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:00.744'!
testNoReferences
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	self assert: (sup references size ) = 0.
! !

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:34:53.652'!
testWithReferences
	
	| sup advancedObj simpleObj references |
	advancedObj := AMMMetaObjectAdvancedExample new.
	simpleObj := AMMMetaObjectSimpleExample new.
	sup := AMMMetaObject for: advancedObj.
	
	advancedObj otherObject: simpleObj.
	
	references := sup references.
	self assert: ( references size ) = 1.
	
	self assert: (( references at: 1) =  (AMMMetaObject for: simpleObj )).
	! !

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:35:23.328'!
testWithReferencesReturnsMetaObject
	
	| sup advancedObj simpleObj references |
	advancedObj := AMMMetaObjectAdvancedExample new.
	simpleObj := AMMMetaObjectSimpleExample new.
	advancedObj otherObject: simpleObj.
	sup := AMMMetaObject for: advancedObj.
	
	references := sup references.

	self assert: (( references at: 1) =  (AMMMetaObject for: simpleObj )).
	! !

TestCase subclass: #AMMMetaObjectSizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:08.454'!
testClassSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	self assert: (sup sizeOfObject ) = 34.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:12.68'!
testClassWithReferencesSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectAdvancedExample new.
	self assert: (sup sizeOfObject ) = 12.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:16.883'!
testSuperclassSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleSubExample new.
	self assert: (sup sizeOfObject ) = 38.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:21.596'!
testUnextendedClassesCannotBeUsedSize
	
	| sup  error |
	[
		sup := AMMMetaObject for: AMMMetaObjectUnextendedExample new.
	] on: Exception do: [:e | error := e ].

	self assert: error notNil.
! !

UiContainer subclass: #AMMGarbageCollector
	instanceVariableNames: 'algorithm status objects algorithmString algorithmStatusString buttonPause buttonPlay buttonStep buttonReset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 08:54:22.031'!
addPanel

	|panel |
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (452@30).
	panel position: (8@8).
	panel hResizing: (#spaceFill).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#topLeft).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	
	self addMorphBack: panel.
	^ panel! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/2/2013 16:36:13.685'!
algorithm

	^ algorithm! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/24/2013 15:30:00.78'!
algorithm: anObject

		algorithm ifNotNil: [
			self unregisterSignalsForAlgorithm.
		].
	
		algorithm := anObject.
	
		algorithm ifNotNil: [
			self registerSignalsForAlgorithm.
			self algorithm objects: self objects.
			self enableOnlyPlayAndStepControl.
		].
	
		self refresh.
		self updateAlgorithmString.

! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/16/2013 16:30:32.082'!
algorithmStatusString

	^ algorithmStatusString! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/16/2013 16:30:29.618'!
algorithmStatusString: anObject

	algorithmStatusString := anObject! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:56:40.732'!
algorithmString

	^ algorithmString! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/10/2013 13:56:40.742'!
algorithmString: anObject

	algorithmString := anObject! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/19/2013 09:39:57.752'!
buttonPause

	^ buttonPause ifNil: [
		buttonPause := self createButtonNamed: 'buttonPause' withIcon: (UiDiagonaIcons icon0341Normal)
	]
! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/19/2013 09:08:28.274'!
buttonPlay

	^ buttonPlay ifNil: [
		buttonPlay := self createButtonNamed: 'buttonPlay' withIcon: (UiDiagonaIcons icon0331Normal)
	]! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/19/2013 10:04:33.014'!
buttonReset

	^ buttonReset ifNil: [
		buttonReset := self createButtonNamed: 'buttonReset' withIcon: (UiDiagonaIcons icon0324Normal) 
	]! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/19/2013 09:11:16.296'!
buttonStep

	^ buttonStep ifNil: [
		buttonStep := self createButtonNamed: 'buttonStep' withIcon: (UiDiagonaIcons icon0343Normal) 
	]! !

!AMMGarbageCollector methodsFor: 'button' stamp: 'sw 6/19/2013 09:08:03.404'!
createButtonNamed: aName withIcon: anIcon
|button|

	button := UiPushButton new.
	button changeTableLayout.
	button extent: (49@21).
	button position: (194@12).
	button hResizing: (#shrinkWrap).
	button vResizing: (#shrinkWrap).
	button minWidth: (2).
	button minHeight: (2).
	button cellInset: (4).
	button cellPositioning: (#center).
	button cellSpacing: (#none).
	button layoutInset: (2@0 corner: 2@0).
	button listCentering: (#topLeft).
	button listDirection: (#leftToRight).
	button listSpacing: (#none).
	button maxCellSize: (1073741823).
	button minCellSize: (0).
	button wrapCentering: (#topLeft).
	button wrapDirection: (#none).
	button frameFractions: (0@0 corner: 1@1).
	button frameOffsets: (0@0 corner: 0@0).
	button balloonText: (nil).
	button balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	button enabled: (true).
	"button setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'."
	button icon: anIcon.
	button color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	button checkable: (false).
	button checked: (false).
	button autoExclusive: (false).
	button setProperty: #objectName toValue: aName.
	button setProperty: #objectDescription toValue: 'Play Scenario'.
	button text: nil.
	
	^ button! !

!AMMGarbageCollector methodsFor: 'button' stamp: 'sw 6/19/2013 10:11:42.968'!
disableAllButResetControls

	self buttonPause enabled: false.
	self buttonPlay enabled: false.
	self buttonStep enabled: false.
	self buttonReset enabled: true.
	! !

!AMMGarbageCollector methodsFor: 'button' stamp: 'sw 6/19/2013 10:09:32.258'!
disableAllControls

	self buttonPause enabled: false.
	self buttonPlay enabled: false.
	self buttonStep enabled: false.
	self buttonReset enabled: false.
	! !

!AMMGarbageCollector methodsFor: 'button' stamp: 'sw 6/19/2013 10:11:51.075'!
enableOnlyPauseControl
	
	self disableAllButResetControls.
	self buttonPause enabled: true.
	! !

!AMMGarbageCollector methodsFor: 'button' stamp: 'sw 6/19/2013 10:11:55.178'!
enableOnlyPlayAndStepControl
	
	self disableAllButResetControls.
	self buttonStep enabled: true.
	self buttonPlay enabled: true.
	! !

!AMMGarbageCollector methodsFor: 'stepping and presenter' stamp: 'sw 6/12/2013 00:06:47.339'!
gcStep

	self algorithm ifNotNil: [
		self algorithm step.
	].
	self render.! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 10:13:27.879'!
handleAlgorithmFinished

	self stopAutoplay.
	self disableAllButResetControls.
	self render.

! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 10:17:11.426'!
handleEventResetAlgorithm
	
	self algorithm ifNotNilDo: [:alg |
		alg reset
		].
	self stopAutoplay.
	self render.! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 08:59:29.317'!
handleEventStartAutoplay
	
	self startAutoplay! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 08:58:44.574'!
handleEventStep

	self gcStep! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 09:00:03.802'!
handleEventStopAutoplay
	
	self stopAutoplay! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/19/2013 10:07:27.263'!
handlePhaseFinished

	self stopAutoplay.
	self render.

! !

!AMMGarbageCollector methodsFor: 'event handling' stamp: 'sw 6/18/2013 17:41:11.206'!
handleRefreshView
	
	self refreshView.! !

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 09:47:58.056'!
initialize 

	super initialize.
	self changeTableLayout.
	self extent: (150@100).
	self listCentering: (#topLeft).
	self listDirection: (#topToBottom).
	self color: Color red.
	
	self initializeHeaderPanel.
	self initializeControlPanel.
	self initializeAlgorithmHeaderPanel.
	self initializeAlgorithmStatusPanel.	

	self registerSignalsForGeneralControls.
	
	self disableAllControls.! !

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 08:47:07.758'!
initializeAlgorithmHeaderPanel

	self algorithmString: (StringMorph contents: '').
	self algorithmString position: (5@70).
	self algorithmString extent: (90@10).
	self algorithmString lock.
	self addPanel addMorph: (self algorithmString).! !

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 08:47:30.514'!
initializeAlgorithmStatusPanel	
	
	self algorithmStatusString: (StringMorph contents: '').
	self algorithmStatusString position: (5@85).
	self algorithmStatusString extent: (90@10).
	self algorithmStatusString lock.
	self addPanel addMorph: (self algorithmStatusString).! !

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 10:04:05.231'!
initializeControlPanel

	| panel |
	
	panel := self addPanel.
	panel addChild: self buttonPlay.
	panel addChild: self buttonPause.
	panel addChild: self buttonStep.
	panel addChild: self buttonReset.
	! !

!AMMGarbageCollector methodsFor: 'initialization' stamp: 'sw 6/19/2013 08:46:04.765'!
initializeHeaderPanel

	| text |
	text := (StringMorph contents: ('<font family="Accuny" size="9">Garbage Collector</font>') asHtmlText).
	text position: (5@5).
	text lock.

	self addPanel addMorph: text.! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/3/2013 15:12:39.438'!
objects

	^ objects! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/10/2013 13:25:56.055'!
objects: anCollection

	objects := anCollection.
	
	self algorithm ifNotNil:  [ self algorithm objects: self objects ]! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'ci 6/25/2013 19:34:42.309'!
refresh
	
	(self algorithm isNil)
		ifTrue: [
			self status: #inactive.
			self color: (Color r:0.61 g:0 b:0.11).
		]	
		ifFalse: [
			self status: #active.
			self color: (Color r: 0.17 g:0.56 b:0).
		]
! !

!AMMGarbageCollector methodsFor: 'event-triggering' stamp: 'sw 6/18/2013 17:47:43.103'!
refreshView
	
	self emitInOwnerChain! !

!AMMGarbageCollector methodsFor: 'events-listening' stamp: 'sw 6/18/2013 17:40:38.432'!
registerSignalsForAlgorithm

	self connect: self algorithm signal: #phaseFinished toSelector: #handlePhaseFinished.
	self connect: self algorithm signal: #refreshView toSelector: #handleRefreshView.
	self connect: self algorithm signal: #algorithmFinished toSelector: #handleAlgorithmFinished.
! !

!AMMGarbageCollector methodsFor: 'events-listening' stamp: 'sw 6/19/2013 10:05:24.434'!
registerSignalsForGeneralControls 

	self connect: self buttonStep signal:#clicked: toSelector:  #handleEventStep.
	self connect: self buttonPlay signal:#clicked: toSelector:  #handleEventStartAutoplay.	
	self connect: self buttonPause signal:#clicked: toSelector: #handleEventStopAutoplay.
	self connect: self buttonReset signal:#clicked: toSelector: #handleEventResetAlgorithm.! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'sw 6/19/2013 10:07:10.896'!
render
	
	self refresh.
	self updateAlgorithmString.! !

!AMMGarbageCollector methodsFor: 'event-triggering' stamp: 'sw 6/19/2013 09:29:32.547'!
startAutoplay

	self enableOnlyPauseControl.
	
	self emitInOwnerChain.
! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/2/2013 17:28:20.022'!
status

	^ status! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'rm 6/2/2013 17:35:49.76'!
status: aStatus

	status := aStatus.
! !

!AMMGarbageCollector methodsFor: 'event-triggering' stamp: 'sw 6/19/2013 09:29:41.038'!
stopAutoplay

	self enableOnlyPlayAndStepControl.
	
	self emitInOwnerChain.
! !

!AMMGarbageCollector methodsFor: 'events-listening' stamp: 'sw 6/18/2013 17:40:54.008'!
unregisterSignalsForAlgorithm

	self disconnectSignal: #phaseFinished  from: self algorithm.
	self disconnectSignal: #refreshView  from: self algorithm.
	self disconnectSignal: #algorithmFinished  from: self algorithm.
! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/24/2013 15:33:18.189'!
updateAlgorithmString
	|algorithmString statusString|
	
	statusString := ''.
	algorithmString:= ''.
	self algorithm ifNotNil: [ 	
			statusString:= ('<font family="Accuny" size="9">',self algorithm currentTitle,'</font>') asHtmlText.
			algorithmString:= ('<font family="Accuny" size="9">',self algorithm class nameOfAlgorithm,'</font>') asHtmlText.
	 ].
			
	self algorithmStatusString contents: statusString.
	self algorithmString contents: algorithmString.

! !

Workspace subclass: #AMMWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/1/2013 14:55:14.932'!
bindingOf: aString

	^ super bindingOf: aString! !

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/2/2013 19:36:20.407'!
bindings

	^ bindings! !

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/1/2013 14:35:20.637'!
bindings: someBindings

	self setBindings: someBindings.
	! !

!AMMWorkspace methodsFor: 'completion' stamp: 'sw 6/1/2013 14:27:05.395'!
createCompletionController
	
	^ OController model: self! !

BorderedMorph subclass: #AMMObjectNodeReference
	instanceVariableNames: 'textMorph referenceCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectNodeReference class methodsFor: 'as yet unclassified' stamp: 'ci 6/23/2013 12:10:14.951'!
newAt: aPosition

	|object|
	
	object := (self new).
	object position: (20@5 + aPosition).
	
	^ object.! !

!AMMObjectNodeReference methodsFor: 'initialization' stamp: 'ci 6/23/2013 12:00:50.868'!
initialize
	super initialize.
	
	self color: (Color r: 200 g: 200 b: 200).
	self borderColor: Color black.
	self borderWidth: 1.
	self extent: (15@15).
	
	self textMorph: (StringMorph  contents: '').
	self addMorphCentered: (self textMorph).! !

!AMMObjectNodeReference methodsFor: 'accessing' stamp: 'ci 6/23/2013 11:01:41.969'!
textMorph

	^ textMorph! !

!AMMObjectNodeReference methodsFor: 'accessing' stamp: 'ci 6/23/2013 11:01:41.981'!
textMorph: anObject

	textMorph := anObject! !

SHTextStylerST80 subclass: #AMMTextStyler
	instanceVariableNames: 'customTextAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMTextStyler commentStamp: '<historical>' prior: 0!
Regular Shout text styler with the ability to override some attributes dynamically.!

!AMMTextStyler class methodsFor: 'style table' stamp: 'sw 6/1/2013 10:49:11.113'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
						
	(default 								( black )	)
	(invalid 								( red ) 	)
	(excessCode 							( red )	)
	(comment 								( green	muchDarker ) nil	#'Bitmap Segoe UI' 15)
	(unfinishedComment 					( green	muchDarker )	)
	(#'$'									( magenta muchDarker) 	)
	(character							( magenta muchDarker) 	)
	(integer								( magenta muchDarker) 	)
	(number								( magenta muchDarker) 	)
	(#-										( magenta muchDarker) 	)
	(symbol									( magenta muchDarker) 	)	
	(stringSymbol							( magenta muchDarker) 	)	
	(literalArray							( magenta muchDarker) 	)
	(string									( magenta ) 	)
	(unfinishedString						( magenta ) 	)
	(assignment								( black )					)
	(ansiAssignment 						( black )					)
	(literal									( black )					)
	(keyword								( black )					)
	(binary 								( black )					)
	(unary									( black )					)
	(incompleteKeyword						( black )					)
	(incompleteBinary 						( black )					)
	(incompleteUnary						( black )					)
	(undefinedKeyword						( red )					)
	(undefinedBinary 						( red )					)
	(undefinedUnary						( red )					)													
	(patternKeyword 						( black ) bold				)
	(patternBinary 							( black ) bold				)
	(patternUnary							( black ) bold				)
	(#self 									( cyan muchDarker )	bold	)
	(#super									( cyan muchDarker )	bold	)
	(#true 									( cyan muchDarker )	bold	)
	(#false 									( cyan muchDarker )	bold	)
	(#nil 									( cyan muchDarker )	bold	)
	(#thisContext 							( cyan muchDarker )	bold	)
	(#return								( black )	bold				)
	(patternArg 							( blue muchDarker ) 		)	
	(methodArg 								( blue muchDarker ) 		)		
	(blockPatternArg 						( yellow muchDarker ) 		)		
	(blockArg 								( yellow muchDarker ) 		)	
	(argument 								( blue muchDarker ) 		)		
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						black		) 
	(rightParenthesis1						black		) 
	(leftParenthesis2						black		)  
	(rightParenthesis2						black		)  
	(leftParenthesis3						black		) 
	(rightParenthesis3						black		) 
	(leftParenthesis4						black		) 
	(rightParenthesis4						black		) 
	(leftParenthesis5						black		)  
	(rightParenthesis5						black		) 
	(leftParenthesis6						black		) 
	(rightParenthesis6						black		) 
	(leftParenthesis7						black		) 
	(rightParenthesis7						black		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								black		) 
	(blockEnd1								black		) 
	(blockStart2								black		) 
	(blockEnd2								black		) 
	(blockStart3								black		) 
	(blockEnd3								black		) 
	(blockStart4								black		) 
	(blockEnd4								black		) 
	(blockStart5								black		) 
	(blockEnd5								black		) 
	(blockStart6								black		) 
	(blockEnd6								black		) 
	(blockStart7								black		) 
	(blockEnd7								black		) 																																																
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							black		) 
	(blockTempBar 							black		) 
	(blockArgsBar							black		) 
	(primitive								gray		)
	(externalFunctionCallingConvention		gray		)
	(module									gray		)
	(blockTempVar 							( gray darker ) 		)	
	(blockPatternTempVar					( gray darker ) 		)	
	(instVar 								( blue muchDarker ) 		)	
	(workspaceVar							( blue muchDarker ) 		)	
	(undefinedIdentifier						( red ) 		)	
	(incompleteIdentifier					( blue muchDarker ) 		)	
	(tempVar								( gray darker ) 		)	
	(patternTempVar						( gray darker ) 		)	
	(poolConstant							( blue muchDarker ) 		)	
	(classVar								( blue muchDarker ) 	bold	)	
	(globalVar								( blue muchDarker ) 	bold	) )
							! !

!AMMTextStyler class methodsFor: 'styling' stamp: 'sw 6/1/2013 10:49:11.131'!
styleExpression: aString

	^ self new styleExpression: aString! !

!AMMTextStyler class methodsFor: 'style table' stamp: 'sw 6/1/2013 10:49:11.125'!
subduedStyleTable

	^ self defaultStyleTable! !

!AMMTextStyler methodsFor: 'private' stamp: 'sw 6/1/2013 14:25:27.904'!
attributesFor: aSymbol

	^ (((super attributesFor: aSymbol) ifNil: [#()]), 
		(self customTextAttributes at: aSymbol ifAbsent: [#()])) ifEmpty: []! !

!AMMTextStyler methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:49:11.09'!
customTextAttributes

	^ customTextAttributes ifNil: [customTextAttributes := IdentityDictionary new].! !

!AMMTextStyler methodsFor: 'styling' stamp: 'sw 6/1/2013 10:49:11.098'!
styleExpression: aString
	"Convertes the given expression into a styled text."
	
	| result |
	result := aString asText copy.
	self privateStyle: result.
	^ result! !

RectangleMorph subclass: #AMMHeapCell
	uses: AMMObjectRepresentationDrawing
	instanceVariableNames: 'id object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMHeapCell class
	uses: AMMObjectRepresentationDrawing classTrait
	instanceVariableNames: ''!

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 10:16:12.805'!
defaultWidth

	^ 3! !

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:06:40.889'!
withId: aNumber
	| cell |
	cell := self new.
	cell extent: (4 @ 100).
	cell color:  AMMObjectsRepresentation emptyColor.
	cell borderWidth: 1.
	cell id: aNumber.
	^ cell.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:22:06.905'!
id
	^ id.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:24:54.733'!
id: aNumber
	id := aNumber.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:56:37.144'!
object

	^ object! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 6/17/2013 16:32:40.145'!
object: anObject

	object ifNotNil: [ self unregisterSignalsForObject ].
	object := anObject.	

	self setBorderColor.		
	self setTooltip.
	self setColor.

	object ifNotNil: [ 
		self registerSignalsForObject 
	].
! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:16:17.794'!
refresh 

	self setColor.
	! !

!AMMHeapCell methodsFor: 'trait-object-representation-drawing' stamp: 'sw 6/17/2013 16:56:55.773'!
setColor 
	
	(self object isNil)
		ifTrue: [ self color: AMMObjectsRepresentation defaultColor ]
		ifFalse: [
			(self object state = #marked) 
				ifTrue: [ self color: AMMObjectsRepresentation markedColor ]
				ifFalse: [ 
					((self object state = #active) or: (self object flag = #activeTraversal)) 
						ifTrue: [ self color: AMMObjectsRepresentation activeColor ]
						ifFalse: [ 
							(self object flag = #doneTraversal)
								ifTrue: [self color: AMMObjectsRepresentation visitedColor ]
								ifFalse: [self color: AMMObjectsRepresentation defaultColor ].					
							] 
					]
			]! !

UiTextEdit subclass: #AMMSourceCodeEdit
	instanceVariableNames: 'theClass autoCreateArtifacts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeEdit commentStamp: '<historical>' prior: 0!
This is a text edit to modify a method's source.!

!AMMSourceCodeEdit class methodsFor: 'testing' stamp: 'sw 6/1/2013 10:14:42.153'!
isWidgetClass

	^ true! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 12:29:23.309'!
widgetCategory

	^ 'Input Widgets'! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.166'!
widgetClassIcon

	^ UiFugueIcons scriptCodeIcon! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 12:29:13.386'!
widgetClassName

	^ 'AMM Source Code Edit'! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.911'!
acceptChanges

	self readOnly
		ifTrue: [^ self].

	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	(self parse and: [self compile]) ifTrue: [
		"Play done animation."
		self autoAccept ifFalse: [  
			ViAnimatedImageMorph
				flyOutOn: self
				with: UiFugueIcons tickIcon].
		
		^ super acceptChanges].
		
	self grabKeyboard.! !

!AMMSourceCodeEdit methodsFor: 'actions - activation' stamp: 'sw 6/1/2013 10:14:41.948'!
activateObject: anObject

	self flag: #informationHiding. "mt: Shoud not decide if class here!!"
	anObject isBehavior
		ifTrue: [self artifactRequested: anObject].! !

!AMMSourceCodeEdit methodsFor: 'actions - activation' stamp: 'sw 6/1/2013 10:14:41.955'!
activateSymbol: aSymbol

	(Smalltalk at: aSymbol ifAbsent: []) ifNotNil: [:obj |
		^ self activateObject: obj].
	
	(SystemNavigation default allImplementorsOf: aSymbol)
		ifNotNil: [:refs | refs size == 1 ifTrue: [^ self artifactRequested: refs first]].
	
	^ self textMorph requestImplementors: aSymbol! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.963'!
artifactRequested: anObject

	self emitInOwnerChain.  ! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.004'!
autoCreateArtifacts

	^ autoCreateArtifacts ifNil: [autoCreateArtifacts := false]! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.013'!
autoCreateArtifacts: aBoolean

	autoCreateArtifacts := aBoolean.! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/1/2013 10:14:42.071'!
compile

	^ true! !

!AMMSourceCodeEdit methodsFor: 'drawing' stamp: 'sw 6/1/2013 10:14:42.1'!
drawOn: aCanvas

	| c |
	super drawOn: aCanvas.
	
	self hasKeyboard ifTrue: [c := self colorFocusBorder].
	
	c ifNotNil: [
			
		aCanvas
			line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
			line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
		aCanvas
			line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
		aCanvas
			frameRectangle: self innerBounds
			color: (c alpha: 0.8)].! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/2/2013 17:01:38.817'!
evaluate

	^ Compiler evaluate: self theText asString! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/2/2013 17:01:42.793'!
evaluateSelection

	^ self textMorph editor evaluateSelection! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.973'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'initialization' stamp: 'sw 6/1/2013 10:49:28.566'!
initialize
	
	super initialize.
	
	self textMorph
		font: Preferences standardCodeFont;
		styler: AMMTextStyler new;
		margins: (4@0 corner: 4@0).
	
	self connect: self textMorph signal: #focusChanged: toSelector: #onFocusChanged:.
	self connect: self textMorph signal: #repeatedReturnPressed: toSelector: #onRepeatedReturnPressed:.

	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp:.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown:.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.984'!
mouseWheelDown: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].
		
	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.991'!
mouseWheelUp: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].

	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.998'!
newArtifactRequested

	self emitInOwnerChain.  ! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.923'!
onFocusChanged: aLocalRectangle
	"Mapping to global coordinates."
	
	self focusChanged: (self textMorph bounds: aLocalRectangle in: self world).! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.933'!
onRepeatedReturnPressed: count

	self autoCreateArtifacts ifFalse: [^ self].

	count == 2 ifTrue: [
		(UiMessage information: 'Tap once more for new object.')
			bottomLeft: (self textMorph localPointToGlobal: self textMorph editor pointBlock bottomLeft) - (0@5);
			openInWorld].
		
	count == 3 ifTrue: [
		self textMorph undoRepeatedReturnPress.
		self newArtifactRequested].! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.024'!
optimalWidth
	"Override to ignore comments."
	
	| maxWidth |
	maxWidth := 0.

	((self theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		copyReplaceAll: String tab with: '   ')
	   linesDo: [:line | 
			maxWidth := maxWidth max: (self textMorph textStyle defaultFont widthOfString: line)].
		
	^ maxWidth + self scrollBarThickness + 20 ! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/1/2013 10:14:42.094'!
parse

	^ true! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.941'!
revertChanges

	self readOnly
		ifTrue: [^ self].
		
	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	super revertChanges.
	
	"Play done animation."
	ViAnimatedImageMorph
		flyOutOn: self
		with: UiFugueIcons crossIcon.! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.036'!
selectedSelector
	"If possible, return the selector that is behind the current selection."
	
	^ self textMorph editor selectedSelector! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.043'!
sourceCode

	^ self theText! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.05'!
sourceCode: someCode

	self theText: someCode.! !

!AMMSourceCodeEdit methodsFor: 'accessing - private' stamp: 'sw 6/1/2013 12:08:56.241'!
textModelClass

	^ AMMWorkspace! !

!AMMSourceCodeEdit methodsFor: 'accessing - private' stamp: 'sw 6/1/2013 10:48:03.983'!
textMorphClass

	^ AMMSourceCodeTextMorph! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.057'!
theClass

	^ theClass! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.063'!
theClass: aClassOrMetaClass

	theClass = aClassOrMetaClass ifTrue: [^ self].
	
	self flag: #merge. "mt: store reference only once; maybe in model"
	theClass := aClassOrMetaClass.
	self model theClass: theClass.
	
	self textMorph styler ifNil: [^ self].
	theClass ifNil: [^ self].
		
	theClass isMeta
		ifTrue: [self textMorph styler: ViTextStylerForClass new]
		ifFalse: [self textMorph styler: ViTextStyler new].
	
	self textMorph styler classOrMetaClass: theClass.! !

UiTextEdit subclass: #AMMTextEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:06:08.274'!
doIt

	self doIt: self selectedText asString.! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:00:30.778'!
doIt: aString

	self emit. ! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:51:45.23'!
textMorphClass

	^ AMMTextMorph! !

UiTestCase subclass: #AMMObjectGraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:47:56.734'!
setUp 
	super setUp.
	sut objects: OrderedCollection new.! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:03:38.691'!
subjectClass

	^ AMMObjectGraph! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:06:11.201'!
testANewObjectGraphHasNoNodes

	self assert: sut objectNodes size == 0.
	self assert: sut submorphs size == 0.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:47:03.565'!
testRenderingCreatesObjectNodes
	
	sut objects add: (AMMMetaObject for: AMMMetaObjectSimpleExample new).
	self assert: sut objectNodes isEmpty.
	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 11:16:44.821'!
testRenderingPreservesObjects
	
	| adv objects sim |
	self assert: sut objects isEmpty.
	adv := AMMMetaObject for: AMMMetaObjectAdvancedExample new.
	sim := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	adv object otherObject: sim object.
	objects := OrderedCollection new add: adv; add: sim; yourself.
	sut objects:  objects.
	
	self deny: sut objects isEmpty.
	sut render.
	self deny: sut objects isEmpty.	! !

NCAAConnectorMorph subclass: #AMMConnectorMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMConnectorMorph methodsFor: 'accessing' stamp: 'sw 6/12/2013 00:33:45.221'!
label

	^ label! !

!AMMConnectorMorph methodsFor: 'accessing' stamp: 'sw 6/12/2013 00:33:45.224'!
label: anObject

	label := anObject! !

UiTextEditor subclass: #AMMSourceCodeEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeEditor class methodsFor: 'keyboard shortcut tables' stamp: 'sw 6/1/2013 10:52:44.959'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
		
	cmdActions at: $o asciiValue + 1 put: #openIt:! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/11/2013 23:35:08.595'!
browseIt

	| aSymbol anEntry brow |

	self lineSelectAndEmptyCheck: [^ self].

	Preferences alternativeBrowseIt ifTrue: [^ self browseClassFromIt].

	(aSymbol := self selectedSymbol) isNil ifTrue: [^ morph flash].

	aSymbol first isUppercase
		ifTrue:
			[anEntry := (Smalltalk
				at: aSymbol
				ifAbsent:
					[ self systemNavigation browseAllImplementorsOf: aSymbol.
					^ nil]).
			anEntry ifNil: [^ morph flash].
			(anEntry isKindOf: Class)
				ifFalse:	[anEntry := anEntry class].
			brow := Preferences browseToolClass new.
			brow setClass: anEntry selector: nil.
			brow class
				openBrowserView: (brow openEditString: nil)
				label: 'System Browser']
		ifFalse:
			[self systemNavigation browseAllImplementorsOf: aSymbol]! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 11:24:14.164'!
doIt: aKeyboardEvent
	
	self doIt.
	^ true.
! !

!AMMSourceCodeEditor methodsFor: 'do-its' stamp: 'ci 6/23/2013 11:17:33.037'!
evaluateSelectionAndDo: aBlock

	| result |
	result := super evaluateSelectionAndDo: aBlock.
	morph expressionEvaluated: result.  
	^ result  ! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/10/2013 12:58:01.28'!
exploreIt
	self evaluateSelectionAndDo: [:result | result explore ]! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.912'!
implementorsOfIt

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ morph flash].
	morph requestImplementors: aSelector.  ! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/10/2013 12:58:16.553'!
inspectIt
	self evaluateSelectionAndDo: [:result | result inspect ]! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 10:52:44.945'!
openIt

	self lineSelectAndEmptyCheck: [^ self].
	
	self selectedSymbol ifNotNil: [:symbol |
		^ morph editView activateSymbol: symbol].
	self selectedSelector ifNotNil: [:symbol |
		^ morph editView activateSymbol: symbol].

	"self evaluateSelection ifNotNil: [:result |
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifFalse: [^ model activateObject: result]]."
	
	^ morph flash! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 10:52:44.953'!
openIt: aKeyboardEvent
	"Open code."

	self openIt.
	^ true! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.928'!
sendersOfIt

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ morph flash].
	morph requestSenders: aSelector.  ! !

!AMMSourceCodeEditor methodsFor: 'signals' stamp: 'sw 6/1/2013 15:00:04.932'!
sourceCodeExecuted

	self emit! !

!AMMSourceCodeEditor methodsFor: 'signals' stamp: 'sw 6/2/2013 20:42:56.212'!
sourceCodeExecuted: withResult
	self halt.
	self emit! !

UiTextEditor subclass: #AMMTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEditor methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:59:06.57'!
doIt: anEvent

	self morph editView doIt.
	^ true! !

Object subclass: #AMMApplication
	instanceVariableNames: 'metaObjects heap garbageCollector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/24/2013 14:33:16.226'!
addMetaObject: aMetaObject 
	
	((self metaObjects indexOf: aMetaObject) > 0) ifTrue: [ ^ self ].
	self heap setAddressFor: aMetaObject.
	self metaObjects add: aMetaObject.

	self connect: aMetaObject signal: #changed toSelector:#handleEventObjectChanged: pattern:#(0).
	self updateMetaObjectsForReferences: aMetaObject.
! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/7/2013 09:35:40.655'!
addObject: anObject

	anObject ifNil: [ ^ self errorOccured: 'nil cannot be added to objects']. 
	(self includesObject: anObject ) ifTrue: [ ^ self errorOccured: 'Objects cannot be added twice']. 
	
	[
		self addMetaObject: (AMMMetaObject for: anObject).
	] on: AMMHeapOutOfSpaceError do: [ self errorOccured: 'No space left for this insertion' ].
! !

!AMMApplication methodsFor: 'events-triggering' stamp: 'sw 6/4/2013 09:53:28.984'!
errorOccured: aMessage
	
	self emit! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/10/2013 11:55:46.057'!
garbageCollector

	^ garbageCollector! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/10/2013 12:02:13.426'!
garbageCollector: aGarbageCollector

	aGarbageCollector objects: self metaObjects.
	garbageCollector := aGarbageCollector! !

!AMMApplication methodsFor: 'event handling' stamp: 'sw 6/17/2013 16:19:51.309'!
handleEventObjectChanged! !

!AMMApplication methodsFor: 'event handling' stamp: 'sw 6/25/2013 23:50:10.17'!
handleEventObjectChanged: anObject 

	self updateMetaObjectsForReferences: anObject.! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:17:23.286'!
heap

	^ heap! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:17:23.289'!
heap: anObject

	heap := anObject! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:43:39.317'!
includesObject: anObject

	^ (self metaObjects detect: [:metaObject | metaObject object = anObject ] ifNone:[nil]) notNil 
	! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:43:15.353'!
metaObjects

	^ metaObjects ifNil: [metaObjects := OrderedCollection new]! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/10/2013 11:53:41.429'!
metaObjects: anObject

	metaObjects := anObject! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/17/2013 11:38:42.598'!
setReachableObjectsAsRoot: boundObjects
	"When the the object in the binded objects (attached collection) the metaobject is a root. "

	self metaObjects do:[ :metaObject | | name|
		name := boundObjects keyAtValue: (metaObject object) ifAbsent: [ nil].
		metaObject name: name.
		]! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:09:50.143'!
updateMetaObjectsForReferences: aMetaObject

	aMetaObject references do: 
		[ :otherMetaObject | 
			[
				self addMetaObject: otherMetaObject 
			] on: AMMHeapOutOfSpaceError do: [ :err | | selectorName |
			
			selectorName := (aMetaObject refenceNameOf: otherMetaObject) asString, ':'.			
			aMetaObject object perform: (selectorName asSymbol) with: nil.
			self errorOccured: err messageText.
		]
	]	
! !

Object subclass: #AMMBall
	instanceVariableNames: 'diameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Example'!

!AMMBall methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 23:47:01.222'!
diameter 
	<size:8>! !

Object subclass: #AMMGCAlgorithm
	instanceVariableNames: 'phase objects objectStack currentObjectIndex enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGCAlgorithm class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:21:05.377'!
nameOfAlgorithm

	self subclassResponsibility ! !

!AMMGCAlgorithm methodsFor: 'event-triggering' stamp: 'sw 6/10/2013 13:32:57.582'!
algorithmFinished

	self emit! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 18:16:06.108'!
currentObjectFromMemory

	self objects ifNil: [ ^ nil].
	
	((self currentObjectIndex > 0) and: (self objects size >= self currentObjectIndex)) 
		ifTrue:  [ ^ self objects at: self currentObjectIndex ]
		ifFalse: [	 ^ nil ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:18.853'!
currentObjectIndex

	^ currentObjectIndex ifNil: [currentObjectIndex := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:47.427'!
currentObjectIndex: anObject

	currentObjectIndex := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/10/2013 13:57:45.852'!
currentTitle
	
	self subclassResponsibility ! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:17:08.483'!
enter: anObject

	self objectStack at: anObject put: 0.
	anObject flag: #activeTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:37:39.093'!
findNextUntraversedRoot
	" returns first object which hasn't been traversed yet and is a root - therefore globally reachable "

	self objects 
		do:[ :obj | 
				(obj hasBeenTraversed = false and: ( obj isRoot)) 
					ifTrue: [ ^ obj ] 
			].
	^ nil
		! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:26:20.184'!
indexOfLastChildOf: anObject

	^ self objectStack at: anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:23:42.31'!
lastVisitedObject

	^ self objectStack orderedKeys last! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:19:54.82'!
leave: anObject

	self objectStack removeKey: anObject.
	anObject flag: #doneTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:32:24.811'!
nextChildOf: object
	| nextChild  index | 
	
	index := self indexOfLastChildOf: object.
	nextChild :=  object references at: (index +1) ifAbsent: nil.
	self objectStack at: object put:(index +1).

	^ nextChild! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:04:31.413'!
nextObject
| object |
	self objectStack isEmpty 
		ifTrue: [
		"no parent-object is on the stack"
			object := self findNextUntraversedRoot.
			(object isNil) 
				ifFalse: [ self enter: object ].
		] ifFalse: [
		
			object := self nextChildOf: self lastVisitedObject.			
			(object isNil)
				ifTrue: [ 
					" last reference of object was visited, we can leave the object now"
					self leave:  self lastVisitedObject. 
					object := self nextObject.
					] 
				ifFalse: [
					object hasBeenTraversed 
						ifTrue:  [ object := self nextObject.] 
						ifFalse: [ self enter: object ].			
					].
			].
		^ object
! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/19/2013 10:15:56.357'!
nextPhase

	self phase: self phase+1.
	self currentObjectIndex: 0.
	self phaseFinished.
	self class methodDictionary keys 
		detect: [:methodName|
			(((methodName asString) findString: ('phase0', self phase)) > 0 ) ]
		ifNone: [ ^ self algorithmFinished ].! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:44:01.09'!
objectStack
	^ objectStack ifNil: [ objectStack := OrderedKeysIdentityDictionary new ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.47'!
objectStack: anObject

	objectStack := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:30.436'!
objects 
	^ objects! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:15.423'!
objects: anCollection
	objects := anCollection! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:41.905'!
phase

	^ phase ifNil: [ phase := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.468'!
phase: anObject

	phase := anObject! !

!AMMGCAlgorithm methodsFor: 'event-triggering' stamp: 'sw 5/28/2013 10:13:15.262'!
phaseFinished

	self emit! !

!AMMGCAlgorithm methodsFor: 'event-triggering' stamp: 'sw 6/18/2013 17:32:02.508'!
refreshView

	self emit! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/12/2013 00:16:50.665'!
reset
	self objects do: [ :obj | obj flag: #new. obj state: #inactive. ].
	self currentObjectIndex: nil.
	self phase: nil.
	self objectStack removeAll.

	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 6/19/2013 09:53:58.383'!
step
	" executes the method regarding to the current phase of the alogrithm
	e.g. AMMGCAlgorithm >> phase01Starting
	"
	|method|

	method := self class methodDictionary keys 
		detect: [:methodName|
			(((methodName asString) findString: ('phase0', self phase)) > 0 ) ]
		ifNone: [ ^ self algorithmFinished ].
		
	self perform: method.
	! !

AMMGCAlgorithm subclass: #AMMMarkAndSweap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMMarkAndSweap class methodsFor: 'as yet unclassified' stamp: 'rm 6/16/2013 16:21:32.642'!
nameOfAlgorithm

	^ 'Mark and Sweep'! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 6/19/2013 09:56:33.829'!
currentTitle

	| title |
	title := ''.
	(self phase = 0)
		ifTrue: [ title := title, '0. Clear all states: ' ].
		
	(self phase = 1)
		ifTrue: [ title := title, '1. Traverse Tree: ' ].
		
	(self phase = 2)
		ifTrue: [ title := title, '2. Remove unused objects: ' ].
				
	(self phase > 2)
		ifTrue: [ title := 'Done' ].
		
	^ title! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:03:27.698'!
phase00ClearAllStates
	"clear all flags of the objects"
	
	| object lastObject |
	
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			object flag: #clear.
		].
	! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:42:09.262'!
phase01TraverseTree
	
	| object |

	object := self nextObject.

	object ifNil: [ self nextPhase. ].
! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 6/18/2013 17:33:01.774'!
phase02RemoveUnusedObjects
	
	| object lastObject |
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			(object flag = #doneTraversal)
				ifFalse: [ 
					self objects remove: object. 
					self currentObjectIndex: self currentObjectIndex-1.
					object remove.
					self refreshView ]. 
		].! !

AMMGCAlgorithm subclass: #AMMReferenceCounting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

Object subclass: #AMMHistoryManager
	instanceVariableNames: 'application historyIndex history lastHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 20:16:40.137'!
application 
	
	 ^ application! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 19:58:05.523'!
application: anObject

	application := anObject! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 20:00:29.606'!
history

	^ history ifNil:[ history := Dictionary new ]! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 22:16:43.432'!
history: anObject

	history := anObject! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 19:59:36.635'!
historyIndex

	^ historyIndex ifNil:[ historyIndex := 0 ] ! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 19:59:20.787'!
historyIndex: anObject

	historyIndex := anObject! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 22:48:46.29'!
lastHash

	^ lastHash! !

!AMMHistoryManager methodsFor: 'accessing' stamp: 'sw 6/20/2013 22:48:46.293'!
lastHash: anObject

	lastHash := anObject! !

!AMMHistoryManager methodsFor: 'serving' stamp: 'sw 6/25/2013 22:37:53.704'!
loadObjectState

	| metaObjects |
	
	self lastHash: nil.		
	(self history includesKey: self historyIndex)
		ifTrue: [
			metaObjects := (self history at: self historyIndex) deepCopy.
			(self application metaObjects hash ~~ metaObjects hash) 
				ifTrue: [
					self replaceObjects: metaObjects.			
					self lastHash: metaObjects hash.
					]
			] 
		
! !

!AMMHistoryManager methodsFor: 'serving' stamp: 'sw 6/20/2013 23:14:46.964'!
next
	
	"self halt."
	self saveObjectState.
	self historyIndex: self historyIndex +1 .
	self loadObjectState.! !

!AMMHistoryManager methodsFor: 'serving' stamp: 'sw 6/20/2013 23:14:54.008'!
previous

	(self historyIndex > 0)
		ifTrue: [
			self saveObjectState.
			self historyIndex: self historyIndex - 1.
			self loadObjectState.
		].
! !

!AMMHistoryManager methodsFor: 'serving' stamp: 'sw 6/20/2013 22:50:43.065'!
removeSavedObjectStatesAfter: anIndex

	self history keysDo: [:key |
		(key > anIndex) ifTrue: [ 
			self history removeKey: key ]
		].! !

!AMMHistoryManager methodsFor: 'event-triggering' stamp: 'sw 6/20/2013 21:55:48.427'!
replaceObjects: aCollection

	self emit

	! !

!AMMHistoryManager methodsFor: 'serving' stamp: 'sw 6/20/2013 23:05:42.675'!
saveObjectState

	|metaObjects|
	metaObjects := self application metaObjects.

	(self lastHash ~~ metaObjects hash)
		ifTrue: [
			Transcript show: 'saveState - ', self historyIndex; cr.
			self history at: self historyIndex put: (metaObjects deepCopy).

			self removeSavedObjectStatesAfter: self historyIndex.	
			]
! !

Object subclass: #AMMHuman
	instanceVariableNames: 'age father mother name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Example'!

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 12:48:57.059'!
age
	<size:4> 
	
	^ age! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.535'!
age: anObject

	age := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/7/2013 08:59:45.056'!
father
	<reference>
	
	^ father! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.552'!
father: anObject

	father := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/7/2013 08:59:49.404'!
mother
	<reference>
	
	^ mother! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.553'!
mother: anObject

	mother := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/20/2013 11:12:05.335'!
name
	<size:40> " String of 10 characters encoded with unicode "
	
	^ name! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.555'!
name: anObject

	name := anObject! !

Object subclass: #AMMMetaObject
	instanceVariableNames: 'address state hovered flag name object referenceCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMetaObject class
	instanceVariableNames: 'objects methodWrapper'!

AMMMetaObject class
	instanceVariableNames: 'objects methodWrapper'!

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:51:15.667'!
for: anObject

	objects ifNil: [ objects := Dictionary new ].
		
	^ objects at: anObject ifAbsentPut: [ 
		self installWrappersOn: anObject class.
		AMMMetaObject new object: anObject.
	]! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 10:37:14.87'!
installWrappersOn: aClass
	
	| classes |

	classes := self relevantClasses: aClass.
	(self instanceVariablesWithReference: aClass) 
		do: [ :reference | 	| accessor |
			accessor := (reference ,':') asSymbol.
			classes do:[ :kls |  |wrapper|
				wrapper := AMMObjectMethodWrapper on: accessor inClass: kls.
				wrapper ifNotNil: [
					wrapper install.
					self methodWrapper add: wrapper.
				]
			]

		].
			
			! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:51:36.779'!
instanceVariablesWithReference: aClass

	| variableNames classes |
	variableNames := OrderedCollection new.
	classes := self relevantClasses: aClass.
	
	aClass allInstVarNames do: [:varName |
		classes do:[:class | |compiledMethod |
			compiledMethod := class methodDictionary at: varName asSymbol  ifAbsent: [ nil ].
			compiledMethod ifNotNil:[
				(compiledMethod pragmaAt: #reference) notNil 
					ifTrue: [	variableNames add: varName ]
			].
		].

	].
	^ variableNames! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:34:16.725'!
instanceVaribalesWithSize: aClass

	| classes vars |
	classes := self relevantClasses: aClass.

	vars := Dictionary new.
	aClass allInstVarNames do: [:varName |
		vars at: varName put: nil.
		classes do:[:class | |compiledMethod |
			compiledMethod := class methodDictionary at: varName asSymbol  ifAbsent: [ nil ].
			compiledMethod ifNotNil:[
				(compiledMethod pragmaAt: #reference) isNil 
					ifTrue: [	vars at: varName put: ((compiledMethod pragmaAt: #size:) arguments at:1). ]
					ifFalse: [ vars at: varName put: 4 "if the slot is a reference, 32bit/4Byte is needed "]
			].
		].

	].

	^ vars
		! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:48:22.706'!
methodWrapper

	^ methodWrapper ifNil: [ methodWrapper := OrderedCollection new ]! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:33:19.679'!
relevantClasses: aClass

	| classes |
	classes := OrderedCollection new.
	classes add: aClass.

	(aClass superclass = Object)
		ifFalse:  	[
			classes addAll: (self relevantClasses: aClass superclass).
		].

	^ classes

! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 10:41:14.852'!
reset
	
	self uninstallWrappers.
	objects := nil.
! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/11/2013 09:49:07.549'!
uninstallWrappers
	
	self methodWrapper do: [:wrapper |
		wrapper uninstall.
		].
	
	self methodWrapper removeAll.
			! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:47:02.404'!
address

	^ address! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 13:23:48.684'!
address: anAddress

	address := anAddress.
	self changed.! !

!AMMMetaObject methodsFor: 'event-handling' stamp: 'sw 6/25/2013 19:16:54.991'!
changed

	Transcript show: self asString, ' changed'; cr.
	self emitAlways.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:35:16.035'!
flag
	" is used for the garbage collection algorithms"
	^flag! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:15:46.333'!
flag: aSymbol
	" is used for the garbage collection algorithms"
	flag := aSymbol.
	self changed.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 15:12:55.847'!
hasBeenTraversed

	^ (self flag == #doneTraversal) or: (self flag == #activeTraversal) ! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/20/2013 23:13:48.513'!
hash

	^ name hash
		+ (self flag hash) 
		+ (self address hash) 
		+ (self object hash)
		+ (self sizeOfObject hash)	
		+ (self state hash)	! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'ci 6/16/2013 17:11:40.323'!
hovered

	^ hovered! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 12:29:03.666'!
hovered: anObject

	hovered := anObject.
	self changed.! !

!AMMMetaObject methodsFor: 'initialize-release' stamp: 'sw 6/17/2013 11:34:29.339'!
initialize 

	super initialize.

	self flag: #new.
	self hovered: false.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 11:32:42.613'!
isRoot

	^ (self name isNil not)! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'ci 6/28/2013 12:28:04.763'!
loseReference
	self referenceCount: (self referenceCount  - 1 ).
	! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 11:33:24.263'!
name

	^ name! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 11:53:07.203'!
name: anObject

	name := anObject.
	self changed.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:05:36.8'!
object

	^ object! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 13:24:13.686'!
object: anObject

	(self objectIsUsable: anObject)
		ifTrue: [ 
			object := anObject.
			self changed. ] 
		ifFalse: [ AMMObjectIsNotExtended signal: 'Object cannot be used in this context - please extend all accessors with pragmas!!']
		! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/11/2013 09:26:33.591'!
objectIsUsable: anObject
	
	| vars |
	vars := self class instanceVaribalesWithSize: anObject class.
	
	vars keysAndValuesDo: [:varName :varSize | 
		varSize ifNil: [ ^ false]
		].
	
 	^ true! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'ci 6/28/2013 12:27:49.805'!
receiveReference
	self referenceCount: (self referenceCount + 1 ).
	! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/12/2013 00:53:15.957'!
refenceNameOf: aReference

	(self class instanceVariablesWithReference: self object class) do: [:varName | |referencedObject|
		referencedObject := self object perform: (varName asSymbol).
			
		(referencedObject = aReference object)
			ifTrue: [ ^ varName ].
	].

	^ nil! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/26/2013 00:17:14.403'!
referenceCount

	^ referenceCount ifNil: [ referenceCount := 0 ]! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'ci 6/28/2013 13:00:31.376'!
referenceCount: anInteger
	"set the reference Count, i.e. the amount of references to this object"
	
	"Transcript show: 'reference count changed for'; show: self asString; show: anInteger; cr."
	referenceCount := anInteger! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/11/2013 09:35:14.396'!
references 

	| references |
	references := OrderedCollection new.
	(self class instanceVariablesWithReference: self object class)
		 do: [ :varName | | referencedObject |
			referencedObject := self object perform: (varName asSymbol).
			referencedObject ifNotNil:
				[references add: (AMMMetaObject for: referencedObject)].
			].	
	^ references ! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 23:43:44.509'!
remove
	
	self changed ! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/11/2013 09:26:27.267'!
sizeOfObject

	| instanceVariables size |
	instanceVariables := self class instanceVaribalesWithSize: self object class.
	size := 0 .
	instanceVariables valuesDo: [:variableSize | size := size + variableSize ].
	
	^ size! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:17.707'!
state
	" is used for grafical representation "
	^ state! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:58:42.479'!
state: aState
	" is used for graphical representation 
		-> #marked when somebody clicked on it
		-> #active when the algorithm is busy with it
		"

	state := aState.
	
	self changed.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 12:29:14.293'!
toggleHover
	[
		(self hovered) 
			ifTrue: [ self hovered: false ]
		 	ifFalse: [ self hovered: true ].
	] fork.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/17/2013 13:24:59.029'!
toggleState

	(self state = #marked) 
		ifTrue: [ self state: #unmarked.]
	 	ifFalse: [ self state: #marked. ]! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'ci 6/16/2013 17:12:47.873'!
toggleState: aSymbol
	"obsolve so far"
	
	(aSymbol = #hovered) 
		"onMouseOver"
		ifTrue: [ self lastState: self state. self state: #hovered.] 
		"onMouseLeave"
		ifFalse: [ 
			(self state = #hovered) 
				ifTrue: [ self state: self lastState. self lastState: nil. ]
				ifFalse: [
					(self state = #marked) 
						ifTrue: [ self state: #unmarked.]
	 					ifFalse: [ self state: #marked. ]
			]
		].

	! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/4/2013 17:31:14.236'!
variablesNamesOfReferences

	| variableNames classes |
	variableNames := OrderedCollection new.
	classes := self relevantclassesForClass: self object class.
	
	self object class allInstVarNames do: [:varName |
		classes do:[:class | |compiledMethod |
			compiledMethod := class methodDictionary at: varName asSymbol  ifAbsent: [ nil ].
			compiledMethod ifNotNil:[
				(compiledMethod pragmaAt: #reference) notNil 
					ifTrue: [	variableNames add: varName ]
			].
		].

	].
	^ variableNames ! !

Object subclass: #AMMMetaObjectAdvancedExample
	instanceVariableNames: 'otherObject localVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:19.523'!
localVariable
	<size:8>
	^ localVariable! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:12.149'!
localVariable: anObject

	localVariable := anObject! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:25.583'!
otherObject
	<reference>
	^ otherObject! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:12.145'!
otherObject: anObject

	otherObject := anObject! !

Object subclass: #AMMMetaObjectSimpleExample
	instanceVariableNames: 'var1 var2 var3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:21.965'!
var1
	<size: 10>! !

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:25.16'!
var2
	<size:11>! !

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:29.742'!
var3
	<size:13>! !

AMMMetaObjectSimpleExample subclass: #AMMMetaObjectSimpleSubExample
	instanceVariableNames: 'var4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSimpleSubExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:46:01.128'!
var4
	<size:4>

	^ var4! !

!AMMMetaObjectSimpleSubExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:45:53.337'!
var4: anObject

	var4 := anObject! !

Object subclass: #AMMMetaObjectUnextendedExample
	instanceVariableNames: 'var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

Object subclass: #AMMUnit
	instanceVariableNames: 'currentSequence maxState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:57:49.277'!
heapSize

	self subclassResponsibility ! !

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:45:19.383'!
nameOfUnit

	self subclassResponsibility ! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:24:35.161'!
currentSequence

	^ currentSequence ifNil: [ currentSequence := 0 ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:22:13.117'!
currentSequence: anObject

	currentSequence := anObject! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:37.972'!
disableNextButton

	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/29/2013 08:31:38.83'!
disablePlayControls

	self emit! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:43.176'!
doOnce: aBlock

	(self currentSequence == maxState) 
		ifTrue: [ ^ aBlock value ]! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:26.839'!
enableNextButton

	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:31:36.978'!
enablePlayControls

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 11:11:33.487'!
finished
	
	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'rm 6/19/2013 21:30:33.55'!
getSequenceCount
	| count |
	count := 0.
	self class methodDictionary keys do: [ :methodName |
		(((methodName asString) findString: ('sequence')) > 0 ) ifTrue:[
			count := count + 1.
		]
	].
	^ count! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/4/2013 09:32:28.054'!
makeObjectReachable: anObject withLabel: aLabel

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:20:23.657'!
maxState
	
	^ maxState ifNil: [ maxState := 0 ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:19:45.987'!
maxState: anObject

	maxState := anObject! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:50.345'!
next 

	self currentSequence: self currentSequence +1.
	self showSequence.! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:53.778'!
previous  

	(self currentSequence > 1)
		ifTrue: [
			self currentSequence: (self currentSequence -1).
			]
		ifFalse: [ 
			self currentSequence: 1.
			].
	self showSequence.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:09:11.459'!
reactOnAlgorithmPhaseFinished

	self stopAutoplay.
	
	" do something "
! !

!AMMUnit methodsFor: 'event handling' stamp: 'rm 6/2/2013 17:40:14.009'!
setGCAlgorithm: anAlgorithm

	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/16/2013 10:19:23.847'!
showMessage: aMessage

	self emit.! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:24:06.789'!
showSequence 

	| method |
	self enableNextButton.

	method := self class methodDictionary keys 
		detect: [:methodName|
			(self currentSequence >= 10)
				ifTrue: [
					(((methodName asString) findString: ('sequence', self currentSequence)) > 0 )
					]
				ifFalse: [
					(((methodName asString) findString: ('sequence0', self currentSequence)) > 0)
					]
				]
		ifNone: [ method:= #finished ].
		
	self perform: method.! !

!AMMUnit methodsFor: 'actions' stamp: 'sw 6/3/2013 13:37:58.939'!
sourceCodeActions

	| actions |
	actions := Dictionary new.
	
	^ actions
	! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/3/2013 13:36:58.246'!
sourceCodeExecuted: aSourceCode withBindings: aBindingsDictionary withResult: aResult

	self sourceCodeActions keysAndValuesDo: [ :sourceCode :methodName |
		( sourceCode match: aSourceCode )
			ifTrue: [ self perform: methodName with: aSourceCode with: aBindingsDictionary with: aResult ]
		]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:11:03.757'!
startAutoplay

	self emit.
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:08:50.889'!
stopAutoplay

	self emit.
! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/4/2013 09:32:36.628'!
storeObjectInMemory: anObject

	self emit.! !

AMMUnit subclass: #AMMUnit0
	instanceVariableNames: 'pcI challengeAccomplished'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 10:33:47.112'!
heapSize 

	^ 40! !

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:50:11.957'!
nameOfUnit

	^ 'Welcome'! !

!AMMUnit0 methodsFor: 'accessing' stamp: 'sw 5/24/2013 13:04:42.248'!
initialize 

	super initialize.
	challengeAccomplished := false.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:54:12.931'!
sequence01Start 

	self showMessage:
'Hello you,
You can learn how the mark and sweep algorithm works here. 

Click on next to learn about this learning environment first!!!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 13:40:16.045'!
sequence02IntroduceElements
	
	self doOnce: [
		self fillInitialObjects.
		].
	
	self showMessage:
'You can see various elements here.
On the left side, you find the lecture-selector. Here you can choose a particular topic, you want to dive into.
Next to it, the stepping-menu is located. With this, you can control how algorithms are applied in later lectures. You can step through every single instruction or you can play it up automatically.

On the right hand side you can see the heap, which is the memory representation.
Under the heap, you see another way of representing objects: an object graph.

Click next to continue!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:00.057'!
sequence03IntroduceInteractionWithNodes
	
	self doOnce: [
		self addObject: (AMMObject new size: 5 ; address: 37; yourself).
		challengeAccomplished := false.
		self disableNextButton.
		].
	self showMessage:
'Like everywhere, these objects change frequently. 
So, objects are added and removed from the program.
You will learn, which strategies are applied to remove the objects from the memories regardingly.

You can click on every node to see, where it is located in the heap. Try it!!

'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 13:04:40.784'!
sequence04IntroducePseudoCode
	
	self doOnce: [
		challengeAccomplished := false.
		self disableNextButton.
		].
	
	self showMessage:'This text-field is interactive!!

As everywhere in squeak, you can select text and execute the code.

Please try it!! Select one line of the following pseudo code and execute it!!

int := 0.
int := int + 2.'! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:43.538'!
sequence05IntroduceUnits

	self showMessage:
'You can access many units here. As mentioned before, you can navigate to tehm directly via the lecture-selector.
Otherwise, you can follow our whole course an ... just click next. 
Your first lecture will start immediately.'.
! !

!AMMUnit0 methodsFor: 'actions' stamp: 'sw 6/3/2013 13:37:33.728'!
sourceCodeActions

	| actions |
	actions := Dictionary new.
	actions at: '*int := 0*' put: #variableCreatedWithSourceCode:withBindings:withResult:.
	
	^ actions
	! !

!AMMUnit0 methodsFor: 'actions' stamp: 'sw 6/3/2013 14:14:28.819'!
variableCreatedWithSourceCode: aSourceCode withBindings: aBinding withResult: aResult
	
	((aBinding at: #int) >= 2)
		ifTrue: [ self enableNextButton ].	! !

AMMUnit subclass: #AMMUnit1
	instanceVariableNames: 'nextFreeObjectAddresses john peter greta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:19:11.438'!
heapSize 

	^ 45! !

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:44:55.082'!
nameOfUnit

	^ 'Unit #1'! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:24:21.982'!
reactOnAlgorithmPhaseFinished

	super reactOnAlgorithmPhaseFinished.
	
	(self currentSequence == 9) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. 
		
	(self currentSequence == 11) 
		ifTrue: [
			self algorithm disable.
			self next.
			]. 
	(self currentSequence == 14) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. ! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 14:56:34.724'!
sequence01Start 

	self showMessage:
'"Mark and Sweep is a two phase algorithm
During the first phase reachable objects are visited. 
Each visited object gets marked.
Referenced objects are visited recursively. If an object has been marked already, the recursion is cancelled.

During the second phace all unmarked objects are removed from the memory."'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:40:12.563'!
sequence02ExplainInitiationOfGC 

	self showMessage: '| app |
	
"Mark and sweep is a start-stop algorithm. Therefore the user program is interrupted for the garbage collection. 
	
The garbage collection is started when not enough space is left for a required memory allocation.

To assign the Mark and Sweep Algorithm to our garbage collector execute the following code:"

app garbageCollector algorithm: AMMMarkAndSweap new.

'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:40:22.537'!
sequence03InitiateGC 
	
	self doOnce: [ self disableNextButton ].
	self showMessage: '| app paul peter |

"Ok, so lets create some objects.
For example we use objects like this in our program:"

paul := AMMHuman new.
paul name:''Paul''.

paul father: AMMHuman new.
paul father name: ''Peter''.

"Now we can add the created objects to our app. "
app addObject: paul.

"Please execute the code."
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:40:32.477'!
sequence04RemoveOneObjects
	
	self doOnce: [ self disableNextButton ].

	self showMessage: '| paul |

"In the meantime Paul loses his father.
	
Therefore we want to remove the reference from Paul to his father. Execute:"

paul father: nil.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:26:39.939'!
sequence05ExplainUnneededMemory
	
	self showMessage: '"Hence, Paul is the only object which is reachable globally, Peter is not accessable anymore and could be removed from the memory."
	

'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:40:40.759'!
sequence06CreateMoreObjects 

	self doOnce: [ self disableNextButton ].
	
	self showMessage: '| app |

"Ok, now we have a couple of objects in our memory.

And we want to create further objects.

Therefore, please create a new object with executing the following line (just select it and hit cmd-d):"

app addObject: AMMHuman new.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:27:58.779'!
sequence07OutOfMemory 
	
"	self doOnce: [ self disableNextButton. self enablePlayControls ].
"	
	self showMessage: '"Ups, we are out of memory now.
Almost at least. Our memory is filled with objects, but not all of them are needed anymore.

Here the automatical garbage collection helps out.

As you have learned before, mark and sweep is an start-stop algorithm, which interrupts the user program completely.
This happens now."
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:28:08.822'!
sequence08KindOfReachableObjects
	
	self showMessage: '"The first phase of mark and sweep is about finding referenced objects.
There are 2 different types of reachable objects.

1st: root objects (which are highlighted with a red border in the object graph).
These objects are accessable globally.

2nd: referenced objects
To find out, which objects are reachable, we have to traverse all references of reachable objects."
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:39:50.174'!
sequence09FirstPhase
	
	self doOnce: [ self disableNextButton ].

	self showMessage: ' | app |
	
"The garbage collector has to mark objects in the memory and needs a storage for that.
Therefore before the first phase can start, the garbage collector has to reset the storage. 

You can think about it, as the 0th phase.
	
To start a phase of the garbace collector execute the following command:"

app garbageCollector startAutoplay.

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:30:52.933'!
sequence10ExplainRecursiveMark
	
	self showMessage: '"Well, now we have a consistent state.
	
We can search for all reachable objects!! This is done recursively.

During the marking phase, when an object has not been marked before it is marked. Afterwards all referenced objects are visited and marked.

Object >> mark
	(self markingState !!= #set)
		ifTrue: [
			self markingState: #set.
			self references do: [ :object | 
				object mark.
				].
		]

Your are just one "next"-click away from seeing your first garbage collection!!"
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:41:57.871'!
sequence11ExecuteMark
	
	self doOnce: [ self disableNextButton ].
	
	self showMessage: '| app |

"This mark is executed for every root-object - so for every object which is reachable globally.
	
Therefore, please go ahead and execute the following code!!"
	
app garbageCollector startAutoplay.

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:31:04.351'!
sequence12ExplainResultOfMark
	
	self showMessage: '"Do you see the big gap between the first object (Peter) and the third (Greta). This space is used to store data for the second obejct(John) we created. Hence this data is not accessible anymore, it is completely useless and can be freed.
	
Click next to learn about the 2nd phase of Mark and Sweep."
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:31:10.199'!
sequence13IntroduceSweep
	
	self showMessage: '"At this point of time, we have analysed our memory and found all objects which are still in use.

Now, we have to iterate over all cells of our memory to check, if there are some unused objects in there.

Just to clarify things, a quick reminder.
In the 0th phase, we reset the state of all objects in memory.
In the 1st phase, we mark all reachable objects, which is usually only a subset of all objects.
In the 2nd phase (now), we iterate over all objects in our memory again, to remove all unreachable ones. 

Go ahead and click "Next"!!!!"
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:43:00.072'!
sequence14ExecuteSweep
	
	self doOnce: [ self disableNextButton ].

	self showMessage: '| app |

"Now, we have to iterate over all objects in our memory (heap) and delete them from the storage if they were not accessed in the 2nd phase.

Execute it!!!!"

app garbageCollector startAutoplay.
	
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:51:08.03'!
sequence15ResultOfSweep

	nextFreeObjectAddresses := 13.
	self doOnce: [ self disableNextButton ].
	self showMessage: '| app paul |

"Awesome, you just finished your first (automatic) garbage collection!! Congratulation, user program has enough space available and can store new objects again!!
	
Now, the interruption of the program ends.
Paul is adopted and gets John as a new father, tehrefore we set a new reference"

paul father: AMMHuman new.
paul father name: ''John''.

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'rm 6/16/2013 15:54:19.378'!
sequence16AgainOutOfSpace
	
	self showMessage: '| app |
	
"This can go on, until you are out of space again.
	
At this stage, we would execute the garbage collection again."

app garbageCollector algorithm reset.

"repeat this command until the GC is done"
app garbageCollector startAutoplay. 

"But, unfortunately we would not free any space - hence all objects are reachable and necessary."

'! !

AMMUnit subclass: #AMMUnit2
	instanceVariableNames: 'nextFreeObjectAddresses john peter greta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit2 class methodsFor: 'as yet unclassified' stamp: 'ci 6/23/2013 11:08:25.572'!
heapSize

	^ 40! !

!AMMUnit2 class methodsFor: 'as yet unclassified' stamp: 'ci 6/23/2013 11:08:38.104'!
nameOfUnit

	^ 'Unit #2'! !

!AMMUnit2 methodsFor: 'unit-sequences' stamp: 'ci 6/23/2013 13:09:33.462'!
sequence01Start 

	self showMessage:
'"Reference Counting is a three phase algorithm. During the first phase all references are calculated and the reference count per object is set. In the second phase cyclic references are resolved. In the last phase all nodes with zero references are removed."'.! !

!AMMUnit2 methodsFor: 'unit-sequences' stamp: 'ci 6/23/2013 13:32:02.835'!
sequence02Todo

	self showMessage:
'"Reference Counting does not particularly rely on a GC. Once the reference count of an object is set to 0. It deletes itself. 
All Objects that it holds references to are decremented. reference counting guarantees that objects are destroyed as soon as they become unreachable (wikipedia).

breaking up cyclic structures is a hard thing though, as there are multiple ways to do this:
my suggestion is weak references that do not increment the counter -> refere to an object that is a parent object of me.
week references could be visualized in gray.

when a new reference on an object is set it checks if the referencee can be reached through its own references."'.! !

AMMUnit subclass: #AMMUnitExplorative
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnitExplorative class methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 10:07:49.311'!
nameOfUnit 
	
	^ 'Explorative mode'! !

!AMMUnitExplorative methodsFor: 'as yet unclassified' stamp: 'sw 6/17/2013 16:15:23.638'!
sequence01Start 

	self enablePlayControls.
	
	self showMessage:
'"Play around!!!!"
| app ball paul peter jutta |

ball := AMMBall new.
app addObject: ball.

paul := AMMHuman new.
paul name:''Paul''.
app addObject: paul.

peter := AMMHuman new.
peter name: ''Peter''.

jutta := AMMHuman new.
jutta name: ''Jutta''.

paul father: peter.
paul mother: jutta.

app garbageCollector algorithm: AMMMarkAndSweap new.

app garbageCollector algorithm reset.

'.
! !

BalloonMorph subclass: #AMMBalloonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMBalloonMorph class methodsFor: 'as yet unclassified' stamp: 'ci 6/16/2013 13:25:32.417'!
balloonColor
	^ Color r: 120 g: 120 b: 220 alpha: 0.9.! !

MwMethodWrapper subclass: #AMMObjectMethodWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectMethodWrapper methodsFor: 'as yet unclassified' stamp: 'sw 6/25/2013 09:44:34.639'!
afterMethod: anObject

	(AMMMetaObject for: anObject) changed.! !

!AMMObjectMethodWrapper methodsFor: 'as yet unclassified' stamp: 'ci 6/28/2013 13:35:06.731'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."

	^ [
		"this is called way too often with one reference update. supposed to be called once.
		maybe the wrapper thingy is not the best way to do this."
		anArrayOfObjects ifNotNilDo: [:objects | 
			objects do: [:obj | 
				(AMMMetaObject for: obj) receiveReference.
			].
		 ].
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [ self afterMethod: anObject ]! !
